#define SPELLS_MAX 128
#define SPELLS_NUM 96

#define ORIG_ADVSPELLS_NUM 10
#define ORIG_SPELLS_NUM 70

#define SPELL_MEMORIZED 1
#define SPELL_TEMPORARY 2

#define ANIMS_MAX 128
#define ANIMS_NUM 91

#define ANIM_FEAR 83
#define ANIM_DEATH_CLOUD 84
#define ANIM_DEATH_BLOW 85
#define ANIM_TOUGHNESS 86
#define ANIM_BEHEMOTHS_CLAWS 87
#define ANIM_INCINERATION 88
#define ANIM_HOUR_OF_POWER 89
#define ANIM_GOLDEN_TOUCH 90

#define AI_CASTER 0
#define AI_ENEMY 1

#define ARTIFACTS_NUM 144
#define HEROES_NUM 156

enum SpellID : int
{
   SPELL_SUMMON_BOAT = 0x0,
   SPELL_SCUTTLE_BOAT = 0x1,
   SPELL_VISIONS = 0x2,
   SPELL_VIEW_EARTH = 0x3,
   SPELL_DISGUISE = 0x4,
   SPELL_VIEW_AIR = 0x5,
   SPELL_FLY = 0x6,
   SPELL_WATER_WALK = 0x7,
   SPELL_DIMENSION_DOOR = 0x8,
   SPELL_TOWN_PORTAL = 0x9,
   SPELL_QUICKSAND = 0xA,
   SPELL_LAND_MINE = 0xB,
   SPELL_FORCE_FIELD = 0xC,
   SPELL_FIRE_WALL = 0xD,
   SPELL_EARTHQUAKE = 0xE,
   SPELL_MAGIC_ARROW = 0xF,
   SPELL_ICE_BOLT = 0x10,
   SPELL_LIGHTNING_BOLT = 0x11,
   SPELL_IMPLOSION = 0x12,
   SPELL_CHAIN_LIGHTNING = 0x13,
   SPELL_FROST_RING = 0x14,
   SPELL_FIREBALL = 0x15,
   SPELL_INFERNO = 0x16,
   SPELL_METEOR_SHOWER = 0x17,
   SPELL_DEATH_RIPPLE = 0x18,
   SPELL_DESTROY_UNDEAD = 0x19,
   SPELL_ARMAGEDDON = 0x1A,
   SPELL_SHIELD = 0x1B,
   SPELL_AIR_SHIELD = 0x1C,
   SPELL_FIRE_SHIELD = 0x1D,
   SPELL_PROTECTION_FROM_AIR = 0x1E,
   SPELL_PROTECTION_FROM_FIRE = 0x1F,
   SPELL_PROTECTION_FROM_WATER = 0x20,
   SPELL_PROTECTION_FROM_EARTH = 0x21,
   SPELL_ANTI_MAGIC = 0x22,
   SPELL_DISPEL = 0x23,
   SPELL_MAGIC_MIRROR = 0x24,
   SPELL_CURE = 0x25,
   SPELL_RESURRECTION = 0x26,
   SPELL_ANIMATE_DEAD = 0x27,
   SPELL_SACRIFICE = 0x28,
   SPELL_BLESS = 0x29,
   SPELL_CURSE = 0x2A,
   SPELL_BLOODLUST = 0x2B,
   SPELL_PRECISION = 0x2C,
   SPELL_WEAKNESS = 0x2D,
   SPELL_STONE_SKIN = 0x2E,
   SPELL_DISRUPTING_RAY = 0x2F,
   SPELL_PRAYER = 0x30,
   SPELL_MIRTH = 0x31,
   SPELL_SORROW = 0x32,
   SPELL_FORTUNE = 0x33,
   SPELL_MISFORTUNE = 0x34,
   SPELL_HASTE = 0x35,
   SPELL_SLOW = 0x36,
   SPELL_SLAYER = 0x37,
   SPELL_FRENZY = 0x38,
   SPELL_TITANS_LIGHTNING_BOLT = 0x39,
   SPELL_COUNTERSTRIKE = 0x3A,
   SPELL_BERSERK = 0x3B,
   SPELL_HYPNOTIZE = 0x3C,
   SPELL_FORGETFULNESS = 0x3D,
   SPELL_BLIND = 0x3E,
   SPELL_TELEPORT = 0x3F,
   SPELL_REMOVE_OBSTACLE = 0x40,
   SPELL_CLONE = 0x41,
   SPELL_SUMMON_FIRE_ELEMENTAL = 0x42,
   SPELL_SUMMON_EARTH_ELEMENTAL = 0x43,
   SPELL_SUMMON_WATER_ELEMENTAL = 0x44,
   SPELL_SUMMON_AIR_ELEMENTAL = 0x45,
   SPELL_STONE_GAZE = 0x46,
   SPELL_POISON = 0x47,
   SPELL_BIND = 0x48,
   SPELL_DISEASE = 0x49,
   SPELL_PARALYZE = 0x4A,
   SPELL_AGE = 0x4B,
   SPELL_DEATH_CLOUD = 0x4C,
   SPELL_THUNDERBOLT = 0x4D,
   SPELL_DISPEL_HELPFUL_SPELLS = 0x4E,
   SPELL_DEATH_STARE = 0x4F,
   SPELL_ACID_BREATH = 0x50,
   SPELL_FEAR = 0x51,
   SPELL_DEATH_CLOUD_NEW = 0x52,
   SPELL_DEATH_BLOW = 0x53,
   SPELL_DRAIN_LIFE = 0x54,
   SPELL_SUMMON_SPRITE = 0x55,
   SPELL_SUMMON_MAGIC_ELEMENTAL = 0x56,
   SPELL_SUMMON_FIREBIRD = 0x57,
   SPELL_MOBILITY = 0x58,
   SPELL_EYE_OF_THE_MAGI = 0x59,
   SPELL_TOUGHNESS = 0x5A,
   SPELL_BEHEMOTHS_CLAWS = 0x5B,
   SPELL_INCINERATION = 0x5C,
   SPELL_EXPLOSION = 0x5D,
   SPELL_HOUR_OF_POWER = 0x5E,
   SPELL_GOLDEN_TOUCH = 0x5F
};

const SpellID creatureSpell[] =
{
   SPELL_STONE_GAZE, SPELL_BIND, SPELL_PARALYZE, SPELL_DEATH_CLOUD, SPELL_THUNDERBOLT,
   SPELL_DISPEL_HELPFUL_SPELLS, SPELL_DEATH_STARE, SPELL_ACID_BREATH
};

const SpellID newSpell[] =
{
   SPELL_POISON, SPELL_DISEASE, SPELL_AGE, SPELL_FEAR, SPELL_DEATH_CLOUD_NEW,
   SPELL_DEATH_BLOW, SPELL_DRAIN_LIFE, SPELL_SUMMON_SPRITE, SPELL_SUMMON_MAGIC_ELEMENTAL, SPELL_SUMMON_FIREBIRD,
   SPELL_MOBILITY, SPELL_EYE_OF_THE_MAGI, SPELL_TOUGHNESS, SPELL_BEHEMOTHS_CLAWS, SPELL_INCINERATION,
   SPELL_EXPLOSION, SPELL_HOUR_OF_POWER, SPELL_GOLDEN_TOUCH
};

const char* oldSpellName[] =
{
   "Summon Boat", "Scuttle Boat", "Visions", "View Earth", "Disguise",
   "View Air", "Fly", "Water Walk", "Dimension Door", "Town Portal",
   "Quicksand", "Land Mine", "Force Field", "Fire Wall", "Earthquake",
   "Magic Arrow", "Ice Bolt", "Lightning Bolt", "Implosion", "Chain Lightning",
   "Frost Ring", "Fireball", "Inferno", "Meteor Shower", "Death Ripple",
   "Destroy Undead", "Armageddon", "Shield", "Air Shield", "Fire Shield",
   "Protection from Air", "Protection from Fire", "Protection from Water", "Protection from Earth", "Anti-Magic",
   "Dispel", "Magic Mirror", "Cure", "Resurrection", "Animate Dead",
   "Sacrifice", "Bless", "Curse", "Bloodlust", "Precision",
   "Weakness", "Stone Skin", "Disrupting Ray", "Prayer", "Mirth",
   "Sorrow", "Fortune", "Misfortune", "Haste", "Slow",
   "Slayer", "Frenzy", "Titan's Lightning Bolt", "Counterstrike", "Berserk",
   "Hypnotize", "Forgetfulness", "Blind", "Teleport", "Remove Obstacle",
   "Clone", "Sunmmon Fire Elemental", "Summon Earth Elemental", "Summon Water Elemental", "Summon Air Elemental"
};

const char* newSpellName[] =
{
   "Poison", "Disease", "Age", "Fear", "Death Cloud",
   "Death Blow", "Drain Life", "Summon Sprite", "Summon Magic Elemental", "Summon Firebird",
   "Mobility", "Eye of the Magi", "Toughness", "Behemoth's Claws", "Incineration",
   "Explosion", "Hour of Power", "Golden Touch"
};

const char* gmnMsk = "*.xgm?";
const char* cgmMsk = "*.xcgm";
const char* tgmMsk = "*.xtgm";
const char* gmnExt = ".XGM%d";
const char* cgmExt = ".XCGM";
const char* gmnStr = "%s.XGM%d";
const char* cgmStr = "XCGM";
const char* tgmStr = "XTGM";

// LOD
const int lodType[] = {5, 1, 3};

enum FSpellFlags
{
   SF_BATTLE_SPELL = 0x1,
   SF_MAP_SPELL = 0x2,
   SF_TIME_SCALE = 0x4,
   SF_CREATURE_SPELL = 0x8,
   SF_SINGLE_TARGET = 0x10,
   SF_SINGLE_SHOOTING_STACK = 0x20,
   SF_EXPERT_MASS_VERSION = 0x40,
   SF_TARGET_ANYWHERE = 0x80,
   SF_REMOVE_OBSTACLE = 0x100,
   SF_DAMAGE_SPELL = 0x200,
   SF_MIND_SPELL = 0x400,
   SF_FRIENDLY_MASS = 0x800,
   SF_NOT_AT_WAR_MACHINE = 0x1000,
   SF_SPELL_FROM_ARTIFACT = 0x2000,
   SF_DEFENSIVE = 0x4000,
   SF_AI_DAMAGE_SPELL = 0x8000,
   SF_AI_AREA_EFFECT = 0x10000,
   SF_AI_MASS_DAMAGESPELL = 0x20000,
   SF_AI_NON_DAMAGE_SPELL = 0x40000,
   SF_AI_CREATURES = 0x80000,
   SF_AI_ADVENTUREMAP = 0x100000
};

enum TSex : int
{
   eSexMale = 0,
   eSexFemale = 1
};

enum TRace
{
};

enum THeroClass : int
{
   eClassKnight = 0,
   eClassCleric = 1,
   eClassRanger = 2,
   eClassDruid = 3,
   eClassAlchemist = 4,
   eClassWizard = 5,
   eClassDemoniac = 6,			 // eClassPagan = 6,
   eClassHeretic = 7,
   eClassDeathKnight = 8,
   eClassNecromancer = 9,
   eClassOverlord = 10,
   eClassWarlock = 11,
   eClassBarbarian = 12,
   eClassBattleMage = 13,
   eClassBeastmaster = 14,
   eClassWitch = 15,
								 // kNumHeroClasses = 16
   eClassPlaneswalker = 16,
   eClassElementalist = 17,
   kNumHeroClasses = 18
};

enum THeroID : int
{
   eHeroMostPowerful = -3,		 // Not in the dump
   eHeroNone = -1,
   eHeroRandom = -1,			 // Not in the dump
   eHeroOrrin = 0,				 // eHeroGier = 0,
   eHeroValeska = 1,			 // eHeroRislav = 1,
   eHeroEdric = 2,				 // eHeroDesslock = 2,
   eHeroSylvia = 3,				 // eHeroCuthbert = 3,
   eHeroLordHaart = 4,
   eHeroSorsha = 5,
   eHeroCristian = 6,			 // eHeroSirChristian = 6,
   eHeroTyris = 7,
   eHeroRion = 8,
   eHeroAdela = 9,
   eHeroCuthbert = 10,			 // eHeroHester = 10,
   eHeroAdelaide = 11,
   eHeroIngham = 12,
   eHeroSanya = 13,
   eHeroLoynis = 14,
   eHeroCaitlin = 15,
   eHeroMephala = 16,
   eHeroUfretin = 17,
   eHeroJenova = 18,
   eHeroRyland = 19,
   eHeroThorgrim = 20,
   eHeroIvor = 21,
   eHeroClancy = 22,
   eHeroKyrre = 23,
   eHeroCoronius = 24,
   eHeroUland = 25,
   eHeroElleshar = 26,
   eHeroGem = 27,
   eHeroMalcom = 28,
   eHeroMelodia = 29,
   eHeroAlagar = 30,
   eHeroAeris = 31,
   eHeroPiquedram = 32,
   eHeroThane = 33,
   eHeroJosephine = 34,
   eHeroNeela = 35,
   eHeroTorosar = 36,
   eHeroFafner = 37,
   eHeroRissa = 38,
   eHeroIona = 39,
   eHeroAstral = 40,
   eHeroHalon = 41,
   eHeroSerena = 42,
   eHeroDaremyth = 43,
   eHeroTheodorus = 44,
   eHeroSolmyr = 45,
   eHeroCyra = 46,
   eHeroAine = 47,
   eHeroFiona = 48,
   eHeroRashka = 49,
   eHeroMarius = 50,
   eHeroIgnatius = 51,
   eHeroOctavia = 52,
   eHeroCalh = 53,
   eHeroPyre = 54,
   eHeroNymus = 55,
   eHeroAyden = 56,
   eHeroXyron = 57,
   eHeroAxsis = 58,
   eHeroOlema = 59,
   eHeroCalid = 60,
   eHeroAsh = 61,
   eHeroZydar = 62,
   eHeroXarfax = 63,
   eHeroStraker = 64,
   eHeroVokial = 65,
   eHeroMoandor = 66,
   eHeroCharna = 67,
   eHeroTamika = 68,
   eHeroIsra = 69,
   eHeroClavius = 70,
   eHeroGalthran = 71,
   eHeroSeptienna = 72,
   eHeroAislinn = 73,
   eHeroSandro = 74,
   eHeroNimbus = 75,
   eHeroThant = 76,
   eHeroXsi = 77,
   eHeroVidomina = 78,
   eHeroNagash = 79,
   eHeroLorelei = 80,
   eHeroArlach = 81,
   eHeroDace = 82,
   eHeroAjit = 83,
   eHeroDamacon = 84,
   eHeroGunnar = 85,
   eHeroSynca = 86,
   eHeroShakti = 87,
   eHeroAlamar = 88,
   eHeroJaegar = 89,
   eHeroMalekith = 90,
   eHeroJeddite = 91,
   eHeroGeon = 92,
   eHeroDeemer = 93,
   eHeroSephinroth = 94,
   eHeroDarkstorn = 95,
   eHeroYog = 96,
   eHeroGurnisson = 97,
   eHeroJabarkas = 98,
   eHeroShiva = 99,
   eHeroGretchin = 100,
   eHeroOris = 101,
   eHeroKrellion = 102,
   eHeroCragHack = 103,
   eHeroTyraxor = 104,
   eHeroGird = 105,
   eHeroVey = 106,
   eHeroDessa = 107,
   eHeroTerek = 108,
   eHeroZubin = 109,
   eHeroGundula = 110,
   eHeroSaurug = 111,
   eHeroBron = 112,
   eHeroDrakon = 113,
   eHeroWystan = 114,
   eHeroTazar = 115,
   eHeroAlkin = 116,
   eHeroKorbac = 117,
   eHeroGerwulf = 118,
   eHeroBroghild = 119,
   eHeroMirlanda = 120,
   eHeroRosic = 121,
   eHeroVoy = 122,
   eHeroVerdish = 123,
   eHeroMerist = 124,
   eHeroStyg = 125,
   eHeroAndra = 126,
   eHeroTiva = 127,
   eHeroPasis = 128,
   eHeroThunar = 129,
   eHeroIgnissa = 130,
   eHeroLacus = 131,
   eHeroMonere = 132,
   eHeroErdamon = 133,
   eHeroFiur = 134,
   eHeroKalt = 135,
   eHeroLuna = 136,
   eHeroBrissa = 137,
   eHeroCiele = 138,
   eHeroLabetha = 139,
   eHeroInteus = 140,
   eHeroAenain = 141,
   eHeroGelare = 142,
   eHeroGrindan = 143,
   kNumHeroes = 144,
   eHeroSirMullich = 144,
   eHeroAdrienne = 145,
   eHeroCatherine = 146,
   eHeroDracon = 147,
   eHeroGelu = 148,
   eHeroKilgor = 149,
   eHeroLordHaartLich = 150,
   eHeroMutare = 151,
   eHeroRoland = 152,
   eHeroMutareDrake = 153,
   eHeroBoragus = 154,
   eHeroXeron = 155,
   eHeroGeneralKendal = 156,
   eHeroSirChristian = 157,
   eHeroGemTheSorceress = 158,
   eHeroFinneasVilmar = 159,
   eHeroOrdwald = 160,
   eHeroSandroLich = 161,
   eHeroYogTheBarbarian = 162,
   kNumHeroBios = 163
};

enum TCreatureType : int
{
   eCreatureNone = -1,
   eCreaturePikeman = 0,
   eCreatureHalberdier = 1,
   eCreatureLightCrossbowman = 2,
   eCreatureHeavyCrossbowman = 3,
   eCreatureGriffin = 4,
   eCreatureRoyalGriffin = 5,
   eCreatureSwordsman = 6,
   eCreatureCrusader = 7,
   eCreatureMonk = 8,
   eCreatureZealot = 9,
   eCreatureCavalier = 10,
   eCreatureChampion = 11,
   eCreatureAngel = 12,
   eCreatureArchangel = 13,
   eCreatureCentaur = 14,
   eCreatureEliteCentaur = 15,
   eCreatureDwarf = 16,
   eCreatureBattleDwarf = 17,
   eCreatureWoodElf = 18,
   eCreatureGrandElf = 19,
   eCreaturePegasus = 20,
   eCreatureSilverPegasus = 21,
   eCreatureTreefolk = 22,
   eCreatureBriarTreefolk = 23,
   eCreatureUnicorn = 24,
   eCreatureWarUnicorn = 25,
   eCreatureGreenDragon = 26,
   eCreatureGoldDragon = 27,
   eCreatureApprenticeGremlin = 28,
   eCreatureMasterGremlin = 29,
   eCreatureStoneGargoyle = 30,
   eCreatureObsidianGargoyle = 31,
   eCreatureStoneGolem = 32,
   eCreatureIronGolem = 33,
   eCreatureMage = 34,
   eCreatureArchMage = 35,
   eCreatureGenie = 36,
   eCreatureCaliph = 37,
   eCreatureNagaSentinel = 38,
   eCreatureNagaGuardian = 39,
   eCreatureGiant = 40,						 //eCreatureLesserTitan = 40,
   eCreatureTitan = 41,						 //eCreatureGreaterTitan = 41,
   eCreatureImp = 42,
   eCreatureFamiliar = 43,
   eCreatureGog = 44,
   eCreatureMagog = 45,
   eCreatureHellHound = 46,
   eCreatureCerberus = 47,
   eCreatureDemon = 48,						 //eCreatureSingleHornedDemon = 48,
   eCreatureDualHornedDemon = 49,
   eCreaturePitFiend = 50,
   eCreaturePitFoe = 51,
   eCreatureEfreet = 52,
   eCreatureEfreetSultan = 53,
   eCreatureDevil = 54,
   eCreatureArchDevil = 55,
   eCreatureSkeleton = 56,
   eCreatureSkeletonWarrior = 57,
   eCreatureZombie = 58,
   eCreatureZombieLord = 59,
   eCreatureWight = 60,
   eCreatureWraith = 61,
   eCreatureVampire = 62,
   eCreatureVampireLord = 63,				 //eCreatureNosferatu = 63,
   eCreatureLich = 64,
   eCreaturePowerLich = 65,
   eCreatureBlackKnight = 66,
   eCreatureBlackLord = 67,
   eCreatureBoneDragon = 68,
   eCreatureGhostDragon = 69,
   eCreatureTroglodyte = 70,
   eCreatureInfernalTroglodyte = 71,
   eCreatureHarpy = 72,
   eCreatureHarpyHag = 73,
   eCreatureBeholder = 74,
   eCreatureEvilEye = 75,
   eCreatureMedusa = 76,
   eCreatureMedusaQueen = 77,
   eCreatureMinotaur = 78,
   eCreatureMinotaurKing = 79,
   eCreatureManticore = 80,
   eCreatureScorpicore = 81,
   eCreatureRedDragon = 82,
   eCreatureBlackDragon = 83,
   eCreatureGoblin = 84,
   eCreatureHobgoblin = 85,
   eCreatureGoblinWolfRider = 86,
   eCreatureHobgoblinWolfRider = 87,
   eCreatureOrc = 88,
   eCreatureOrcChieftain = 89,
   eCreatureOgre = 90,
   eCreatureOgreMage = 91,
   eCreatureRoc = 92,
   eCreatureThunderbird = 93,
   eCreatureCyclops = 94,
   eCreatureCyclopsLord = 95,
   eCreatureBehemoth = 96,						//eCreatureYoungBehemoth = 96,
   eCreatureAncientBehemoth = 97,
   eCreatureGnoll = 98,
   eCreatureGnollMarauder = 99,
   eCreaturePrimitiveLizardman = 100,
   eCreatureAdvancedLizardman = 101,
   eCreatureCopperGorgon = 102,
   eCreatureBronzeGorgon = 103,
   eCreatureSerpentFly = 104,
   eCreatureDragonFly = 105,
   eCreatureBasilisk = 106,
   eCreatureGreaterBasilisk = 107,
   eCreatureWyvern = 108,
   eCreatureWyvernMonarch = 109,
   eCreatureHydra = 110,
   eCreatureChaosHydra = 111,
   eCreatureAirElemental = 112,
   eCreatureEarthElemental = 113,
   eCreatureFireElemental = 114,
   eCreatureWaterElemental = 115,
   eCreatureGoldGolem = 116,
   eCreatureDiamondGolem = 117,
   eCreaturePixie = 118,
   eCreatureSprite = 119,
   eCreaturePsychicElemental = 120,
   eCreatureMagicElemental = 121,
   eCreatureNotUsed1 = 122,
   eCreatureIceElemental = 123,
   eCreatureNotUsed2 = 122,
   eCreatureMagmaElemental = 125,
   eCreatureNotUsed3 = 126,
   eCreatureStormElemental = 127,
   eCreatureNotUsed4 = 128,
   eCreatureEnergyElemental = 129,
   eCreatureFirebird = 130,
   eCreaturePhoenix = 131,
   kNumAlignedCreatureTypes = 132,
   eCreatureAzureDragon = 132,
   eCreatureCrystalDragon = 133,
   eCreatureFaerieDragon = 134,
   eCreatureRustDragon = 135,
   eCreatureEnchanter = 136,
   eCreatureSharpshooter = 137,
   eCreatureHalfling = 138,
   eCreaturePeasant = 139,
   eCreatureBoar = 140,
   eCreatureMummy = 141,
   eCreatureNomad = 142,
   eCreatureRogue = 143,
   eCreatureTroll = 144,
   kNumCreatureTypes = 145,
   eCreatureCatapult = 145,
   eCreatureBallista = 146,
   eCreatureFirstAidTent = 147,
   eCreatureAmmoCart = 148,
   eCreatureArrowTower = 149,
   kNumCreatureAndSiegeWeaponTypes = 150,
   kNumSiegeWeaponTypes = 5
};

enum TTownType : int
{
   eTownNone = -1,
   eTownRandom = -1,
   eTownNeutral = -1,
   eTownCastle = 0,
   eTownRampart = 1,
   eTownTower = 2,
   eTownInferno = 3,
   eTownNecropolis = 4,
   eTownDungeon = 5,
   eTownStronghold = 6,
   eTownFortress = 7,
   eTownConflux = 8,
   kNumTownTypes = 9
};

enum ECreatureFlags
{
   CF_DOUBLE_WIDE = 0x1,
   CF_FLYING_ARMY = 0x2,
   CF_SHOOTING_ARMY = 0x4,
   CF_HAS_EXTENDED_ATTACK = 0x8,
   CF_ALIVE = 0x10,
   CF_CATAPULT = 0x20,
   CF_SIEGE_WEAPON = 0x40,
   CF_KING_1 = 0x80,
   CF_KING_2 = 0x100,
   CF_KING_3 = 0x200,
   CF_IMMUNE_TO_MIND_SPELLS = 0x400,
   CF_SHOOTS_RAY = 0x800,
   CF_NO_MELEE_PENALTY = 0x1000,
   CF_UNUSED = 0x2000,
   CF_IMMUNE_TO_FIRE_SPELLS = 0x4000,
   CF_TWO_ATTACKS = 0x8000,
   CF_FREE_ATTACK = 0x10000,
   CF_NO_MORALE = 0x20000,
   CF_UNDEAD = 0x40000,
   CF_MULTI_HEADED = 0x80000,
   CF_FIREBALL_ATTACK = 0x100000,
   CF_IMMOBILIZED = 0x200000,
   CF_SUMMONED = 0x400000,
   CF_CLONE = 0x800000,
   CF_MORALE = 0x1000000,
   CF_WAITING = 0x2000000,
   CF_DONE = 0x4000000,
   CF_DEFENDING = 0x8000000,
   CF_SACRIFICED = 0x10000000,
   CF_RED_COLORING = 0x20000000,
   CF_GREY_COLORING = 0x40000000,
   CF_DRAGON = 0x80000000
};

enum ETown
{
   CASTLE = 0x0,
   RAMPART = 0x1,
   TOWER = 0x2,
   INFERNO = 0x3,
   NECROPOLIS = 0x4,
   DUNGEON = 0x5,
   STRONGHOLD = 0x6,
   FORTRESS = 0x7,
   CONFLUX = 0x8
};

enum TArtifact
{
   eArtifactNone = -1,
   eArtifactSpellbook = 0,
   eArtifactSpellScroll = 1,
   eArtifactHolyGrail = 2,
   eArtifactCatapult = 3, 
   eArtifactBallista = 4,
   eArtifactAmmoCart = 5,
   eArtifactFirstAidTent = 6,
   eArtifactCentaursAxe = 7,
   eArtifactBlackshardOfTheDeadKnight = 8,
   eArtifactGreaterGnollsFlail = 9,
   eArtifactOgresClubOfHavoc = 10,
   eArtifactSwordOfHellfire = 11,
   eArtifactTitansGladius = 12,
   eArtifactShieldOfTheDwarvenLords = 13,
   eArtifactShieldOfTheYawningDead = 14,
   eArtifactBucklerOfTheGnollKing = 15,
   eArtifactTargOfTheRampagingOgre = 16,
   eArtifactShieldOfTheDamned = 17,
   eArtifactSentinelsShield = 18,
   eArtifactHelmOfTheAlabasterUnicorn = 19,
   eArtifactSkullHelmet = 20,
   eArtifactHelmOfTheChaos = 21,
   eArtifactCrownOfTheSupremeMagi = 22,
   eArtifactHellstormHelmet = 23,
   eArtifactThunderHelmet = 24,
   eArtifactBreastplateOfPetrifiedWood = 25,
   eArtifactRibCage = 26,
   eArtifactScalesOfTheGreaterBasilisk = 27,
   eArtifactTunicOfTheCyclopsKing = 28,
   eArtifactBreastplateOfBrimstone = 29,
   eArtifactTitansCuirass = 30,
   eArtifactArmorOfWonder = 31,
   eArtifactSandalsOfTheSaint = 32,
   eArtifactCelestialNecklaceOfBliss = 33,
   eArtifactLionsShieldOfCourage = 34,
   eArtifactSwordOfJudgement = 35,
   eArtifactHelmOfHeavenlyEnlightenment = 36,
   eArtifactQuietEyeOfTheDragon = 37,
   eArtifactRedDragonFlameTongue = 38,
   eArtifactDragonScaleShield = 39,
   eArtifactDragonScaleArmor = 40,
   eArtifactDragonboneGreaves = 41,
   eArtifactDragonWingTabard = 42,
   eArtifactNecklaceOfDragonteeth = 43,
   eArtifactCrownOfDragonTooth = 44,
   eArtifactStillEyeOfTheDragon = 45,
   eArtifactCloverOfFortune = 46,
   eArtifactCardsOfProphecy = 47,
   eArtifactLadybirdOfLuck = 48,
   eArtifactBadgeOfCourage = 49,
   eArtifactCrestOfValor = 50,
   eArtifactGlyphOfGallantry = 51,
   eArtifactSpeculum = 52,
   eArtifactSpyglass = 53,
   eArtifactAmuletOfTheUndertaker = 54,
   eArtifactVampiresCowl = 55,
   eArtifactDeadMansBoots = 56,
   eArtifactGarnitureOfInterference = 57,
   eArtifactSurcoatOfCounterpoise = 58,
   eArtifactBootsOfPolarity = 59,
   eArtifactBowOfElvenCherrywood = 60,
   eArtifactBowstringOfTheUnicornsMane = 61,
   eArtifactAngelFeatherArrows = 62,
   eArtifactBirdOfPerception = 63,
   eArtifactStoicWatchman = 64,
   eArtifactEmblemOfCognizance = 65,
   eArtifactStatesmansMedal = 66,
   eArtifactDiplomatsRing = 67,
   eArtifactAmbassadorsSash = 68,
   eArtifactRingOfTheWayfarer = 69,
   eArtifactEquestriansGloves = 70,
   eArtifactNecklaceOfOceanGuidance = 71,
   eArtifactAngelWings = 72,
   eArtifactCharmOfMana = 73,
   eArtifactTalismanOfMana = 74,
   eArtifactMysticOrbOfMana = 75,
   eArtifactCollarOfConjuring = 76,
   eArtifactRingOfConjuring = 77,
   eArtifactCapeOfConjuring = 78,
   eArtifactOrbOfTheFirmament = 79,
   eArtifactOrbOfSilt = 80,
   eArtifactOrbOfTempestuousFire = 81,
   eArtifactOrbOfDrivingRain = 82,
   eArtifactRecantersCloak = 83,
   eArtifactSpiritOfOppression = 84,
   eArtifactHourglassOfTheEvilHour = 85,
   eArtifactTomeOfFireMagic = 86,
   eArtifactTomeOfAirMagic = 87,
   eArtifactTomeOfWaterMagic = 88,
   eArtifactTomeOfEarthMagic = 89,
   eArtifactBootsOfLevitation = 90,
   eArtifactGoldenBow = 91,
   eArtifactSphereOfPermanence = 92,
   eArtifactOrbOfVulnerability = 93,
   eArtifactRingOfVitality = 94,
   eArtifactRingOfLife = 95,
   eArtifactVialOfLifeblood = 96,
   eArtifactNecklaceOfSwiftness = 97,
   eArtifactBootsOfSpeed = 98,
   eArtifactCapeOfVelocity = 99,
   eArtifactPendantOfDispassion = 100,
   eArtifactPendantOfSecondSight = 101,
   eArtifactPendantOfHoliness = 102,
   eArtifactPendantOfLife = 103,
   eArtifactPendantOfDeath = 104,
   eArtifactPendantOfFreeWill = 105,
   eArtifactPendantOfAgitation = 106,
   eArtifactPendantOfTotalRecall = 107,
   eArtifactPendantOfCourage = 108,
   eArtifactEverflowingCrystalCloak = 109,
   eArtifactRingOfInfiniteGems = 110,
   eArtifactEverpouringVialOfMercury = 111,
   eArtifactInexhaustableCartOfOre = 112,
   eArtifactEversmokingRingOfSulfur = 113,
   eArtifactInexhaustableCartOfLumber = 114,
   eArtifactEndlessSackOfGold = 115,
   eArtifactEndlessBagOfGold = 116,
   eArtifactEndlessPurseOfGold = 117,
   eArtifactLegsOfLegion = 118,
   eArtifactHipsOfLegion = 119,
   eArtifactTorsoOfLegion = 120,
   eArtifactArmsOfLegion = 121,
   eArtifactHeadOfLegion = 122,
   eArtifactSeaCaptainsHat = 123,
   eArtifactSpellbindersHat = 124,
   eArtifactShacklesOfWar = 125,
   eArtifactOrbOfInhibition = 126,
   kNumArtifacts = 127
};

enum EGameResource
{
   const_no_resource = -1,
   WOOD = 0,
   MERCURY = 1,
   ORE = 2,
   SULFUR = 3,
   CRYSTAL = 4,
   GEMS = 5,
   GOLD = 6,
   ABANDONED = 7,
   RES_ARTIFACT = 8,
   RES_SPELL = 9,
   RES_COLOR = 10,
   RES_GOOD_LUCK = 11,
   RES_NEUTRAL_LUCK = 12,
   RES_BAD_LUCK = 13,
   RES_GOOD_MORALE = 14,
   RES_NEUTRAL_MORALE = 15,
   RES_BAD_MORALE = 16,
   RES_EXPERIENCE = 17,
   RES_HERO = 18,
   RES_ARTIFACT_W_TEXT = 19,
   RES_SECONDARY_SKILL = 20,
   RES_MONSTER = 21,
   RES_BUILDING_TT_0 = 22,
   RES_BUILDING_TT_1 = 23,
   RES_BUILDING_TT_2 = 24,
   RES_BUILDING_TT_3 = 25,
   RES_BUILDING_TT_4 = 26,
   RES_BUILDING_TT_5 = 27,
   RES_BUILDING_TT_6 = 28,
   RES_BUILDING_TT_7 = 29,
   RES_PRIMARY_SKILL_ATTACK = 30,
   RES_PRIMARY_SKILL_DEFENSE = 31,
   RES_PRIMARY_SKILL_POWER = 32,
   RES_PRIMARY_SKILL_KNOWLEDGE = 33,
   RES_MANA = 34,
   RES_SMALL_GOLD = 35
};

enum TSkillMastery : int
{
   eMasteryInvalid = -1,
   eMasteryNone = 0,
   eMasteryBasic = 1,
   eMasteryAdvanced = 2,
   eMasteryExpert = 3,
   kNumMasteries = 4
};

enum TSpellSchool : int
{
   const_invalid_school = 0,
   eSchoolAir = 1,
   eSchoolFire = 2,
   eSchoolWater = 4,
   eSchoolEarth = 8,
   eSchoolAll = 15,
   kNumSpellSchools = 4
};

enum TEncodingMethod
{
   eEncodeRaw = 0,
   eEncodeGeneralRLE = 1,
   eEncodeTilesetRLE = 2,
   eEncodeAdvObjRLE = 3,
   kNumEncodingMethods = 4
};