// ===============================================================
// ---------------------- NEW SPELLS PLUGIN ----------------------
// ---------------- https://handbookhmm.ru/forum/ ----------------
// ===============================================================

#include "NewSpells.h"

Patcher* _P;
PatcherInstance* _PI;

char iniPath[MAX_PATH];
char lngPath[MAX_PATH];
char lodPath[MAX_PATH];
char sndPath[MAX_PATH];

_Spell_ Spell[SPELLS_MAX];
_MagicAnim_ SpellAnim[ANIMS_MAX];

// These are not exactly optional tables, so don't remove them
char spellIndirectTableA[] =
{
   // Spells (starting from Quicksand #10)
    0,  1,  2,  2,  3,  4,  4,  4,  4,  4,
    5,  5,  5,  5,  4,  4,  4,  4,  4,  4,
    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
    6,  4,  4,  4,  4,  4,  4,  4,  4,  4,
    4,  4,  4,  4,  4,  4,  4,  4,  4,  5,
    4,  4,  4,  7,  8,  9, 10, 10, 10, 10,
   // Special Abilities (starting from Stone Gaze #71)
    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
    4,
   // New Spells (starting from Fear #81)
    4,  5,  4,  4, 10, 10, 10,  4,  4,  4,
	4,  5,  4,  4,  4
};

char spellIndirectTableB[] =
{
   // Spells (starting from Quicksand #10)
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9,
   10, 11, 12, 13, 14, 15, 16, 17, 17, 17,
   17, 17, 17, 17, 17, 18, 17, 19, 20, 20,
   21, 17, 17, 22, 17, 17, 17, 23, 17, 17,
   17, 17, 17, 17, 17, 17, 17,  7, 17, 24,
   17, 17, 17, 25, 26, 27, 28, 29, 30, 31,
   // Special Abilities (starting from Stone Gaze #71)
   32, 33, 34, 17, 17, 34, 37, 37, 35, 37,
   36,
   // New Spells (starting from Fear #81)
   17, 11, 17, 17, 38, 39, 40, 17, 17, 17,
   17, 11, 17, 17, 17
};

char SetSpellInfluenceTable[] =
{
   // Spells (starting from Shield #27)
    0,  1,  2,  3,  4,  5,  6,  7, 32,  8,
   32, 32, 32, 32,  9, 10, 11, 12, 13, 14,
   32, 15, 16, 17, 18, 19, 20, 21, 22, 23,
   32, 24, 25, 26, 27, 28, 32, 32, 32, 32,
   32, 32, 32,
   // Special Abilities (starting from Stone Gaze #71)
   32, 29, 32, 30, 32, 31, 32, 32, 32, 32,
   32,
   // New Spells (starting from Fear #81)
   32, 32, 32, 32, 32, 32, 32, 32, 32, 32,
   32, 32, 32, 32, 32
};

char spellIndirectTableD[] =
{
   // Spells (starting from Weakness #45)
    0,  1,  9,  2,  9,  9,  9,  9,  3,  4,
    9,  9,  9,  9,  9,  5,  9,  9,  9,  9,
    9,  9,  9,  9,  9,
    // Special Abilities (starting from Stone Gaze #71)
    9,  9,  6,  7,  9,  8,  9,  9,  9,  9,
    9,
    // New Spells (starting from Fear #81)
    9,  9,  9,  9,  9,  9,  9,  9,  9,  9,
	9,  9,  9,  9,  9
};

char spellIndirectTableE[] =
{
   // Spells (starting from Lightning Bolt #17)
    0, 16,  0, 16, 16, 16, 16,  1,  2, 16,
   16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
   16,  3,  4, 16,  5,  6, 16,  7, 16, 16,
   16, 16,  8,  8,  9,  9, 16, 16,  9, 16,
   16, 16, 10, 11, 12, 13, 16, 16, 16, 16,
   16, 16, 16,
   // Special Abilities (starting from Stone Gaze #71)
   14, 15, 16, 16, 16, 16, 16, 16, 16, 16,
   16,
   // New Spells (starting from Fear #81)
   16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
   16, 16, 16, 16, 16
};

char spellIndirectTableF[] =
{
   // Spells (starting from Earthquake #14)
    0,  9,  9,  9,  9,  1,  2,  2,  2,  2,
    3,  3,  3,  9,  9,  9,  9,  9,  9,  9,
    9,  4,  9,  9,  5,  5,  6,  9,  9,  9,
    9,  9,  9,  9,  9,  9,  9,  9,  9,  9,
    9,  9,  9,  9,  9,  9,  9,  9,  9,  7,
    9,  9,  8,  8,  8,  8,
   // Special Abilities (starting from Stone Gaze #71)
    9,  9,  9,  9,  9,  9,  9,  9,  9,  9,
    9,
   // New Spells (starting from Fear #81)
    9,  2,  9,  9,  8,  8,  8,  9,  9,  9,
	9,  2,  9,  9,  9
};

bool shrineSpells[SPELLS_MAX];
char activeSpellMastery[2][21][SPELLS_MAX];
int origNumTroops[2][21];

// Battle Spells
struct SlowSpell
{
   int speedMod;
}
slowSpell[2][21];

struct FearSpell
{
   int speedMod;
   int retalDamageMod;
}
fearSpellParams[4], fearSpell[2][21];

struct PoisonSpell
{
   float healthModFirstRound;
   float healthMod;
   float minHealth;
}
poisonSpellParams[4], poisonSpell[2][21];

struct DiseaseSpell
{
   int attackPenalty;
   int defensePenalty;
   int speedMod;
}
diseaseSpellParams[4], diseaseSpell[2][21];

struct AgeSpell
{
   int healthMod;
}
ageSpell[2][21];

struct ToughnessSpell
{
   int healthMod;
}
toughnessSpell[2][21];

struct ExplosionSpell
{
   bool speedPenalty;
}
explosionSpell[2][21];

struct HourOfPowerSpell
{
   int healthMod;
}
hourOfPowerSpell[2][21];

struct GoldenTouchSpell
{
   int goldForCast;
   int goldForBattle;
}
goldenTouchSpell[2];

// Adventure Spells
struct HeroAdvInfoEx
{
   char mobilityCastCount;
   bool mobilityWonBattle;
   char eyeOfTheMagiCastCount;
}
heroAdvInfoEx[HEROES_NUM];

bool mobilityRequiresBattle;
bool explosionSpeedReduction;
bool incinerationSpecialFeature;
char* mobilityWinBattleMessage;
char* goldenTouchCombatLogMessage;
char* goldenTouchWinBattleMessage;

void playSound(const char* fileName)
{
    CALL_1(_Sample_, __fastcall, 0x59A770, fileName);
}

char* readIniStr(const char* section, const char* key, const char* defaultStr, const char* path)
{
   const int MAX_BUFFER = 601;
   char buffer[MAX_BUFFER];
     
   GetPrivateProfileStringA(section, key, defaultStr, buffer, sizeof(buffer), path);
      
   std::string tmpStr = buffer;
   const std::string subStrA = "\\n";
   const std::string subStrB = "\n";

   int n = 0;
   while ((n = tmpStr.find(subStrA, n)) != std::string::npos)
   {
      tmpStr.replace(n, subStrA.size(), subStrB);
      n += subStrB.size();
   }
         
   char* str = (char*)malloc(tmpStr.size() + 1);
   strcpy(str, tmpStr.c_str());

   return str;
}

int forceCappedDuration[SPELLS_NUM];

HMODULE hHD_SOD;

int __stdcall queueFix(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ecx;
   int queueLength = *(int*)(c->ebp - 0xC);
   int speed = *(int*)(c->ebp - 0x10);

   if (Army->spellInfluence[SPELL_SLOW] || Army->spellInfluence[SPELL_DISEASE] || Army->spellInfluence[SPELL_FEAR])
   {
	  int minSpeedMod = 100;

	  if (Army->spellInfluence[SPELL_SLOW] > queueLength && slowSpell[Army->group][Army->index].speedMod < minSpeedMod)
		 minSpeedMod = slowSpell[Army->group][Army->index].speedMod;

	  if (Army->spellInfluence[SPELL_DISEASE] > queueLength && diseaseSpell[Army->group][Army->index].speedMod < minSpeedMod)
		 minSpeedMod = diseaseSpell[Army->group][Army->index].speedMod;

	  if (Army->spellInfluence[SPELL_FEAR] > queueLength && fearSpell[Army->group][Army->index].speedMod < minSpeedMod)
		 minSpeedMod = fearSpell[Army->group][Army->index].speedMod;

	  speed = (int)(speed * minSpeedMod / 100.0f);
	  *(int*)(c->ebp - 0x10) = speed;
   }

   if (explosionSpell[Army->group][Army->index].speedPenalty)
	  *(int*)(c->ebp - 0x10) = speed + 1;

   c->return_address = (int)hHD_SOD + 0x2264A + 0xC00;
   return NO_EXEC_DEFAULT;
}

void fillSpell(const int id)
{
   int Earth, Water, Fire, Air;
   
   Spell[newSpell[id]].type = GetPrivateProfileIntA(newSpellName[id], "<Type>", 1, iniPath);
   Spell[newSpell[id]].wav_name = readIniStr(newSpellName[id], "<Sound.FileName>", "Bless.wav", iniPath);
   Spell[newSpell[id]].animation_ix = GetPrivateProfileIntA(newSpellName[id], "<Animation.ID>", 0x24, iniPath);
   Spell[newSpell[id]].flags = GetPrivateProfileIntA(newSpellName[id], "<Attributes>", 0x40845, iniPath);
   Spell[newSpell[id]].name = readIniStr(newSpellName[id], "<AbbreviatedName>", "Spell", lngPath);
   Spell[newSpell[id]].short_name = readIniStr(newSpellName[id], "<Name>", "Spell", lngPath);
   Spell[newSpell[id]].level = GetPrivateProfileIntA(newSpellName[id], "<Level>", 1, iniPath);
   Earth = GetPrivateProfileIntA(newSpellName[id], "<School.Earth>", 0, iniPath);
   Water = GetPrivateProfileIntA(newSpellName[id], "<School.Water>", 0, iniPath);
   Fire = GetPrivateProfileIntA(newSpellName[id], "<School.Fire>", 0, iniPath);
   Air = GetPrivateProfileIntA(newSpellName[id], "<School.Air>", 0, iniPath);
   Spell[newSpell[id]].school_flags = (Earth == 1) * SSF_EARTH + (Water == 1) * SSF_WATER + (Fire == 1) * SSF_FIRE + (Air == 1) * SSF_AIR;
   Spell[newSpell[id]].mana_cost[eMasteryNone] = GetPrivateProfileIntA(newSpellName[id], "<Cost.None>", 5, iniPath);
   Spell[newSpell[id]].mana_cost[eMasteryBasic] = GetPrivateProfileIntA(newSpellName[id], "<Cost.Basic>", 4, iniPath);
   Spell[newSpell[id]].mana_cost[eMasteryAdvanced] = GetPrivateProfileIntA(newSpellName[id], "<Cost.Advanced>", 4, iniPath);
   Spell[newSpell[id]].mana_cost[eMasteryExpert] = GetPrivateProfileIntA(newSpellName[id], "<Cost.Expert>", 4, iniPath);
   Spell[newSpell[id]].eff_power = GetPrivateProfileIntA(newSpellName[id], "<Effect.Power>", 0, iniPath);
   Spell[newSpell[id]].effect[eMasteryNone] = GetPrivateProfileIntA(newSpellName[id], "<Effect.None>", 0, iniPath);
   Spell[newSpell[id]].effect[eMasteryBasic] = GetPrivateProfileIntA(newSpellName[id], "<Effect.Basic>", 0, iniPath);
   Spell[newSpell[id]].effect[eMasteryAdvanced] = GetPrivateProfileIntA(newSpellName[id], "<Effect.Advanced>", 1, iniPath);
   Spell[newSpell[id]].effect[eMasteryExpert] = GetPrivateProfileIntA(newSpellName[id], "<Effect.Expert>", 1, iniPath);
   Spell[newSpell[id]].chance2get_var[CASTLE] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Castle>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[RAMPART] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Rampart>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[TOWER] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Tower>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[INFERNO] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Inferno>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[NECROPOLIS] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Necropolis>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[DUNGEON] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Dungeon>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[STRONGHOLD] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Stronghold>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[FORTRESS] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Fortress>", 10, iniPath);
   Spell[newSpell[id]].chance2get_var[CONFLUX] = GetPrivateProfileIntA(newSpellName[id], "<ChanceToGain.Conflux>", 10, iniPath);
   Spell[newSpell[id]].ai_value[eMasteryNone] = GetPrivateProfileIntA(newSpellName[id], "<AIValue.None>", 10, iniPath);
   Spell[newSpell[id]].ai_value[eMasteryBasic] = GetPrivateProfileIntA(newSpellName[id], "<AIValue.Basic>", 10, iniPath);
   Spell[newSpell[id]].ai_value[eMasteryAdvanced] = GetPrivateProfileIntA(newSpellName[id], "<AIValue.Advanced>", 11, iniPath);
   Spell[newSpell[id]].ai_value[eMasteryExpert] = GetPrivateProfileIntA(newSpellName[id], "<AIValue.Expert>", 11, iniPath);
   Spell[newSpell[id]].description[eMasteryNone] =
      readIniStr(newSpellName[id], "<RightClickText.Normal>", "{Spell}\n\nSpell Description.\n", lngPath);
   Spell[newSpell[id]].description[eMasteryBasic] =
      readIniStr(newSpellName[id], "<RightClickText.Basic>", "{Basic Spell}\n\nBasic Spell Description.\n", lngPath);
   Spell[newSpell[id]].description[eMasteryAdvanced] =
      readIniStr(newSpellName[id], "<RightClickText.Advanced>", "{Advanced Spell}\n\nAdvanced Spell Description.\n", lngPath);
   Spell[newSpell[id]].description[eMasteryExpert] =
      readIniStr(newSpellName[id], "<RightClickText.Expert>", "{Expert Spell}\n\nExpert Spell Description.\n", lngPath);
   
   forceCappedDuration[newSpell[id]] = GetPrivateProfileIntA(newSpellName[id], "<ForceCappedDuration>", 0, iniPath);
   if (newSpell[id] == SPELL_INCINERATION)
	  incinerationSpecialFeature = GetPrivateProfileIntA(newSpellName[id], "<SpecialFeature>", 0, iniPath) == 1;
   if (newSpell[id] == SPELL_EXPLOSION)
	  explosionSpeedReduction = GetPrivateProfileIntA(newSpellName[id], "<SpecialFeature>", 0, iniPath) == 1;
}

void initHeroAdvInfoEx()
{
   for (int i = 0; i < HEROES_NUM; ++i)
   {
	  heroAdvInfoEx[i].mobilityCastCount = 0;
	  heroAdvInfoEx[i].mobilityWonBattle = true;
	  heroAdvInfoEx[i].eyeOfTheMagiCastCount = 0;
   }
}

int __stdcall afterInit(LoHook* h, HookContext* c)
{
   // Spell Table
   for (int i = SPELL_SUMMON_BOAT; i <= SPELL_ACID_BREATH; ++i)
      Spell[i] = o_Spell[i];

   for (std::size_t i = 0; i < sizeof(newSpell) / sizeof(int); ++i)
      fillSpell(i);

   // Poison
   poisonSpellParams[eMasteryNone].healthModFirstRound = 0.1f;
   poisonSpellParams[eMasteryNone].healthMod = 0.1f;
   poisonSpellParams[eMasteryNone].minHealth = 0.7f;
   poisonSpellParams[eMasteryBasic].healthModFirstRound = 0.1f;
   poisonSpellParams[eMasteryBasic].healthMod = 0.1f;
   poisonSpellParams[eMasteryBasic].minHealth = 0.7f;
   poisonSpellParams[eMasteryAdvanced].healthModFirstRound = 0.2f;
   poisonSpellParams[eMasteryAdvanced].healthMod = 0.1f;
   poisonSpellParams[eMasteryAdvanced].minHealth = 0.6f;
   poisonSpellParams[eMasteryExpert].healthModFirstRound = 0.3f;
   poisonSpellParams[eMasteryExpert].healthMod = 0.1f;
   poisonSpellParams[eMasteryExpert].minHealth = 0.5f;
   
   // Disease
   diseaseSpellParams[eMasteryNone].attackPenalty = 2;
   diseaseSpellParams[eMasteryNone].defensePenalty = 2;
   diseaseSpellParams[eMasteryNone].speedMod = 20;
   diseaseSpellParams[eMasteryBasic].attackPenalty = 2;
   diseaseSpellParams[eMasteryBasic].defensePenalty = 2;
   diseaseSpellParams[eMasteryBasic].speedMod = 20;
   diseaseSpellParams[eMasteryAdvanced].attackPenalty = 4;
   diseaseSpellParams[eMasteryAdvanced].defensePenalty = 4;
   diseaseSpellParams[eMasteryAdvanced].speedMod = 40;
   diseaseSpellParams[eMasteryExpert].attackPenalty = 4;
   diseaseSpellParams[eMasteryExpert].defensePenalty = 4;
   diseaseSpellParams[eMasteryExpert].speedMod = 40;

   // Fear
   fearSpellParams[eMasteryNone].retalDamageMod = 50;
   fearSpellParams[eMasteryBasic].retalDamageMod = 50;
   fearSpellParams[eMasteryAdvanced].retalDamageMod = 25;
   fearSpellParams[eMasteryExpert].retalDamageMod = 0;

   _PI->WriteDword(0x687FA8, (int)&Spell);

   // Magic Animation Table
   for (int i = 0; i < ANIM_FEAR; ++i)
      SpellAnim[i] = o_MagicAnim[i];

   // Fear
   SpellAnim[ANIM_FEAR].defName = "C07spE0.def";
   SpellAnim[ANIM_FEAR].name = "Fear";
   SpellAnim[ANIM_FEAR].type = 0x101;

   // Death Cloud
   SpellAnim[ANIM_DEATH_CLOUD].defName = "sp04_.def";
   SpellAnim[ANIM_DEATH_CLOUD].name = "DeathCloud";
   SpellAnim[ANIM_DEATH_CLOUD].type = 1;

   // Death Blow
   SpellAnim[ANIM_DEATH_BLOW].defName = "DeathBlow.def";
   SpellAnim[ANIM_DEATH_BLOW].name = "DeathBlow";
   SpellAnim[ANIM_DEATH_BLOW].type = 1;

   // Toughness
   SpellAnim[ANIM_TOUGHNESS].defName = "Toughness.def";
   SpellAnim[ANIM_TOUGHNESS].name = "Toughness";
   SpellAnim[ANIM_TOUGHNESS].type = 1;

   // Behemoth's Claws
   SpellAnim[ANIM_BEHEMOTHS_CLAWS].defName = "Claws.def";
   SpellAnim[ANIM_BEHEMOTHS_CLAWS].name = "Claws";
   SpellAnim[ANIM_BEHEMOTHS_CLAWS].type = 1;

   // Incineration
   SpellAnim[ANIM_INCINERATION].defName = "C13SPF0.def";
   SpellAnim[ANIM_INCINERATION].name = "Incineration";
   SpellAnim[ANIM_INCINERATION].type = 1;

   // Hour of Power
   SpellAnim[ANIM_HOUR_OF_POWER].defName = "HourOPow.def";
   SpellAnim[ANIM_HOUR_OF_POWER].name = "HourOfPower";
   SpellAnim[ANIM_HOUR_OF_POWER].type = 1;

   // Golden Touch
   SpellAnim[ANIM_GOLDEN_TOUCH].defName = "GldTouch.def";
   SpellAnim[ANIM_GOLDEN_TOUCH].name = "GoldenTouch";
   SpellAnim[ANIM_GOLDEN_TOUCH].type = 1;

   // Adventure Spells
   initHeroAdvInfoEx();

   // Animations
   int AnimAddrDefName[] = {0x43F77E, 0x43FB6A, 0x4963FB, 0x4965CF, 0x5A5036, 0x5A6B14, 0x5A7A74, 0x5A962C};
   int AnimAddrName[] = {0x4689C4, 0x49651A, 0x4966CD, 0x5A6D2D, 0x5A7B06};
   
   for (std::size_t i = 0; i < sizeof(AnimAddrDefName) / sizeof(int); ++i)
      _PI->WriteDword(AnimAddrDefName[i], (int)&SpellAnim->defName);

   for (std::size_t i = 0; i < sizeof(AnimAddrName) / sizeof(int); ++i)
      _PI->WriteDword(AnimAddrName[i], (int)&SpellAnim->name);

   _PI->WriteDword(0x43E503, (int)&SpellAnim->type);

   // HD_SOD.dll
   if (GetPrivateProfileIntA("Options", "<UI.QueueFix>", 0, iniPath) == 1)
   {
	  hHD_SOD = GetModuleHandleA("HD_SOD.dll");
	  _PI->WriteLoHook((int)hHD_SOD + 0x22615 + 0xC00, queueFix);
   }

   mobilityRequiresBattle = GetPrivateProfileIntA("Mobility", "<SpecialFeature>", 0, iniPath) == 1;
   if (mobilityRequiresBattle)
	  mobilityWinBattleMessage = readIniStr("Mobility", "<WinBattleMessage>", "%s must win a battle to cast this spell again today.\n", lngPath);

   goldenTouchCombatLogMessage = readIniStr("Golden Touch", "<CombatLogMessage>", "%d gold received.", lngPath);
   goldenTouchWinBattleMessage = readIniStr("Golden Touch", "<WinBattleMessage>", "{Golden Touch} brings you", lngPath);
    
   return EXEC_DEFAULT;
}

// ===============================================================
// ------------------- Availability of spells --------------------
// ---------------------------------------------------------------

// Optional
_SpellBitset_ RMGDisabledSpells;
int __stdcall RMGDisableSpells(LoHook* h, HookContext* c)
{
   for (int iSpell = 0; iSpell < SPELLS_NUM; ++iSpell)
	  RMGDisabledSpells.set(iSpell, pGame->SpellDisabled((SpellID)iSpell));

   CALL_3(void, __thiscall, *(int*)(*(int*)c->ebx + 8), c->ebx, &RMGDisabledSpells, CeilDiv(ORIG_SPELLS_NUM/*SPELLS_MAX*/, 8));

   c->return_address = 0x54AF1E;
   return NO_EXEC_DEFAULT;
}

int __stdcall RMGDisableSpellsInScrollsA(LoHook* h, HookContext* c)
{
   enum SpellID spell = (SpellID)((c->eax - (int)&o_Spell->school_flags) / sizeof(_Spell_));

   if (pGame->SpellDisabled(spell))
   {
      c->return_address = 0x5353EE;
      return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall RMGDisableSpellsInScrollsB(LoHook* h, HookContext* c)
{
   enum SpellID spell = (SpellID)((c->eax - (int)&o_Spell->school_flags) / sizeof(_Spell_));

   if (pGame->SpellDisabled(spell))
   {
      c->return_address = 0x535423;
      return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

void Game::SetSpellsAvailability()
{
   char TextBuffer[64];

   // Old spells
   for (int iSpell = SPELL_SUMMON_BOAT; iSpell <= SPELL_SUMMON_AIR_ELEMENTAL; ++iSpell)
   {
	  int key = GetPrivateProfileIntA("Enabled Spells", TextBuffer, 1, iniPath);
	  sprintf(TextBuffer, "<%s>", oldSpellName[iSpell]);
	  if (key == 0)
		 DisableSpell((SpellID)iSpell);
	  if (key == -1)
		 DisableSpell((SpellID)iSpell, false);
   }

   // Creature spells
   for (std::size_t i = 0; i < sizeof(creatureSpell) / sizeof(int); ++i)
	  DisableSpell(creatureSpell[i]);

   // New spells
   for (std::size_t i = 0; i < sizeof(newSpell) / sizeof(int); ++i)
	  DisableSpell(newSpell[i], GetPrivateProfileIntA(newSpellName[i], "<Enabled>", 1, iniPath) != 1);
}

void hero::AddSpell(int whichSpell)
{
   this->in_spellbook[whichSpell] = SPELL_MEMORIZED;
}

void __fastcall AddSpell(hero* Hero, int unused_edx, int whichSpell)
{
   Hero->AddSpell(whichSpell);
}

// Spells which may appear
_SpellBitset_ mayAppearSpellsEx;
int __stdcall expandMayAppearSpells(LoHook* h, HookContext* c)
{
   int mayAppearSpellsAddr;
   int outputBitsetAddr;
   int returnAddr;
   
   switch (h->GetAddress())
   {
   case 0x5BE518:
	  mayAppearSpellsAddr = c->edi + 0xD4;
	  outputBitsetAddr = (int)&c->ecx;
	  returnAddr = 0x5BE51E;
	  break;
   case 0x5BE52D:
	  mayAppearSpellsAddr = c->edi + 0xD4;
	  outputBitsetAddr = (int)&c->eax;
	  returnAddr = 0x5BE533;
	  break;
   default:
	  mayAppearSpellsAddr = c->esi + 0xD4;
	  outputBitsetAddr = (int)&c->ebx;
	  returnAddr = 0x5BEA2A;
   }
      
   _SpellBitset70_* mayAppearSpells = (_SpellBitset70_*)mayAppearSpellsAddr;
      
   for (int iSpell = 0; iSpell < ORIG_SPELLS_NUM; ++iSpell)
	  mayAppearSpellsEx.set(iSpell, mayAppearSpells->test(iSpell)); 

   for (int iSpell = ORIG_SPELLS_NUM; iSpell < SPELLS_NUM; ++iSpell)
	  if (pGame->SpellDisabled((SpellID)iSpell))
		 mayAppearSpellsEx.set(iSpell);
   
   *(int*)outputBitsetAddr = (int)&mayAppearSpellsEx;
   c->return_address = returnAddr;
   return NO_EXEC_DEFAULT;
}

// Add here *new* spells which must appear in all towns for testing purposes
int mustAppearSpellsList[] = {ID_NONE};

bool mustSpellAppearInTowns(enum SpellID spell)
{
   bool mustAppear = false;

   for (std::size_t i = 0; i < sizeof(mustAppearSpellsList) / sizeof(int); ++i)
   {
      if (spell == mustAppearSpellsList[i])
      {
         mustAppear = true;
         break;
      }
   }

   return mustAppear;
}

// Spells which must appear
_SpellBitset_ mustAppearSpellsEx;
int __stdcall expandMustAppearSpells(LoHook* h, HookContext* c)
{
   _SpellBitset70_* mustAppearSpells = (_SpellBitset70_*)c->eax;
   int spell = c->esi;
   
   for (int iSpell = 0; iSpell < ORIG_SPELLS_NUM; ++iSpell)
	  mustAppearSpellsEx.set(iSpell, mustAppearSpells->test(iSpell)); 

   for (int iSpell = ORIG_SPELLS_NUM; iSpell < SPELLS_NUM; ++iSpell)
	  if (!pGame->SpellDisabled((SpellID)iSpell) && mustSpellAppearInTowns((SpellID)iSpell))
		 mustAppearSpellsEx.set(iSpell);

   c->return_address = mustAppearSpellsEx.test(spell) ? 0x5BEB3B : 0x5BEB1D;
   return NO_EXEC_DEFAULT;
}
// ===============================================================

int __stdcall initSpells(LoHook* h, HookContext* c)
{
   pGame->SetSpellsAvailability();  
   memcpy(&shrineSpells, &pGame->disabled_shrines, sizeof(shrineSpells) / sizeof(bool));   

   c->return_address = 0x4C2641;
   return NO_EXEC_DEFAULT;
}

int Game::FillShrine(int shrineFlags)
{
   int availSpellsNum = 0;

   for (int i = 0; i < SPELLS_NUM; ++i)
   {
      int lvl = o_Spell[i].level - 1;
      if (lvl < 5 && 1 << lvl & shrineFlags && o_Spell[i].school_flags && !shrineSpells[i])
         ++availSpellsNum;
   }

   int spell = 0;
   int chosenSpell = 0;

   if (availSpellsNum)
   {
      int rndSpell = Randint(0, availSpellsNum - 1);
     
      for (int i = 0; i < SPELLS_NUM; ++i)
      {
         int lvl = o_Spell[i].level - 1;
         if (lvl < 5 && 1 << lvl & shrineFlags && o_Spell[i].school_flags && !shrineSpells[i])
         {
            if (spell == rndSpell) break;
            ++spell;
         }
         ++chosenSpell;
      }
     
      shrineSpells[chosenSpell] = true;
   }
   else
   {
      spell = 0;
     
      for (int i = 0; i < SPELLS_NUM; ++i)
      {
         int lvl = o_Spell[i].level - 1;
         if (lvl < 5 && 1 << lvl & shrineFlags && o_Spell[i].school_flags && !disabled_shrines[i])
         {
            shrineSpells[i] = false;
            ++spell;
         }
      }
     
      chosenSpell = spell ? FillShrine(shrineFlags) : ID_NONE;
   }

   return chosenSpell;
}

int __fastcall FillShrine(Game* game, int unused_edx, int shrineFlags)
{
   return game->FillShrine(shrineFlags);
}

bool army::can_attack(army* target)
{
   if (!target || this == target)
      return false;

   if (spellInfluence[SPELL_BERSERK] || target->spellInfluence[SPELL_BERSERK])
      return true;

   int ownerSide = spellInfluence[SPELL_HYPNOTIZE] ? 1 - this->group : this->group;

   return ownerSide != target->group;
}

bool __fastcall can_attack(army* Army, int unused_edx, army* enemy)
{
   return Army->can_attack(enemy);
}

int army::get_adjusted_defense(army* const enemy, bool frenzy_included)
{
   if (frenzy_included && this->spellInfluence[SPELL_FRENZY])
	  return 0;

   int effDefense = this->sMonInfo.defenseSkill;

   if (enemy)
   {
	  double defenseMod = 1.0;

	  if (enemy->armyType == eCreatureBehemoth)
		 defenseMod = 0.6;

	  if (enemy->armyType == eCreatureAncientBehemoth)
		 defenseMod = 0.2;

	  if (enemy->spellInfluence[SPELL_BEHEMOTHS_CLAWS] && !enemy->can_shoot())
		 defenseMod = o_Spell[SPELL_BEHEMOTHS_CLAWS].effect[activeSpellMastery[enemy->group][enemy->index][SPELL_BEHEMOTHS_CLAWS]] / 100.0;

	  effDefense = (int)(effDefense * defenseMod);	  
   }

   if (pCombatManager->IsMoatPresent())
   {
	  int secondHexShift = this->facing ? 1 : -1;
	  int second_hex_ix = this->sMonInfo.attributes & CF_DOUBLE_WIDE ? this->gridIndex + secondHexShift : -1;
	  
	  if (pCombatManager->IsInMoat(this->gridIndex, 0) || pCombatManager->IsInMoat(second_hex_ix, 0))
		 effDefense -= 3;
   }

   return effDefense;
}

int __fastcall GetEffectiveDefenseAgainst(army* Army, int unused_edx, army* target, bool needFrenzyMod)
{
   return Army->get_adjusted_defense(target, needFrenzyMod);   
}

// Hour of Power. Bless
double army::get_average_damage() const
{
   double dmg;

   if (this->spellInfluence[SPELL_BLESS] || this->spellInfluence[SPELL_HOUR_OF_POWER])
	  dmg = this->sMonInfo.damageHighBound + this->blessFactor;
   else if (this->spellInfluence[SPELL_CURSE])
	  dmg = max(1, this->sMonInfo.damageLowBound - this->curseFactor);
   else
	  dmg = (this->sMonInfo.damageLowBound + this->sMonInfo.damageHighBound) / 2.0;

   return dmg;
}

double __fastcall get_average_damage(army* Army)
{
   return Army->get_average_damage();
}

int __stdcall getAverageDamageInt(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;

   c->eax = Army->spellInfluence[SPELL_BLESS] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x4424AF;
   return NO_EXEC_DEFAULT;
}

int __stdcall getUnitCombatValue(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;

   c->edx = Army->spellInfluence[SPELL_BLESS] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x4429BA;
   return NO_EXEC_DEFAULT;
}

int __stdcall randomizeBasicDamage(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ecx;

   c->eax = Army->spellInfluence[SPELL_BLESS] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x442F6A;
   return NO_EXEC_DEFAULT;
}

int __stdcall computeAttackerDamageBonuses(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ebx;

   c->eax = Army->spellInfluence[SPELL_BLESS] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x443486;
   return NO_EXEC_DEFAULT;
}

int __stdcall getAttackDamageHintString(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;

   c->eax = Army->spellInfluence[SPELL_BLESS] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x492FA5;
   return NO_EXEC_DEFAULT;
}

// Hour of Power. Bloodlust
int __stdcall getAdjustedAttack_Bloodlust(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;

   c->eax = Army->spellInfluence[SPELL_BLOODLUST] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x442160;
   return NO_EXEC_DEFAULT;
}

int __stdcall getOgreMageValue(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ebx;

   c->eax = Army->spellInfluence[SPELL_BLOODLUST] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x43BF93;
   return NO_EXEC_DEFAULT;
}

// Hour of Power. Fortune
int __stdcall hourOfPower_Fortune(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->edi;

   c->eax = Army->spellInfluence[SPELL_FORTUNE] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x43DCA5;
   return NO_EXEC_DEFAULT;
}

// Hour of Power. Slayer
int __stdcall getAdjustedAttack_Slayer(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;

   c->eax = Army->spellInfluence[SPELL_SLAYER] || Army->spellInfluence[SPELL_HOUR_OF_POWER];

   c->return_address = 0x442175;
   return NO_EXEC_DEFAULT;
}

float __stdcall SpellCastWorkChance(HiHook* h, CombatManager* combatMgr, int spellId, int casting_side, army* const target_army, bool redirected, bool first_target, bool creature_spell)
{
   if (target_army && target_army->spellInfluence[SPELL_HOUR_OF_POWER])
   	  if (spellId == SPELL_BLESS || spellId == SPELL_CURSE || spellId == SPELL_BLOODLUST || spellId == SPELL_SLAYER || spellId == SPELL_FORTUNE || spellId == SPELL_MISFORTUNE)
		 return 0.0f;

   return CALL_7(float, __thiscall, h->GetDefaultFunc(), combatMgr, spellId, casting_side, target_army, redirected, first_target, creature_spell);   
}

void __stdcall beforeNewDayStart(HiHook* h, Game* game)
{
   initHeroAdvInfoEx();
   CALL_1(void, __thiscall, h->GetDefaultFunc(), game);
}

void __stdcall beforeNewGameStart(HiHook* h, Game* game, int a2)
{
   initHeroAdvInfoEx();
   CALL_2(void, __thiscall, h->GetDefaultFunc(), game, a2);
}

void setupSpellMastery(char value = 0)
{
   memset(&activeSpellMastery, value, sizeof(activeSpellMastery));
}

void initSpellParams()
{
   setupSpellMastery();

   for (int side = ATTACKER; side <= DEFENDER; ++side)
   {
	  goldenTouchSpell[side].goldForCast = 0;
	  goldenTouchSpell[side].goldForBattle = 0;

      for (int i = 0; i < 21; ++i)
      {
         pCombatManager->stack[side][i].Field<float>(0x4C8) = 1.0f;
         slowSpell[side][i].speedMod = 100;
         fearSpell[side][i].speedMod = 100;
         diseaseSpell[side][i].speedMod = 100;
         ageSpell[side][i].healthMod = 100;
		 toughnessSpell[side][i].healthMod = 100;
		 hourOfPowerSpell[side][i].healthMod = 100;
		 explosionSpell[side][i].speedPenalty = false;
      }
   }
}

void __stdcall combatManagerLoadArmies(HiHook* h, CombatManager* combatMgr, bool is_surrounded)
{
   CALL_2(int, __thiscall, h->GetDefaultFunc(), combatMgr, is_surrounded);

   initSpellParams();

   for (int side = ATTACKER; side <= DEFENDER; ++side)
      for (int i = 0; i < 21; ++i)
		 origNumTroops[side][i] = pCombatManager->stack[side][i].creature_id != ID_NONE ? pCombatManager->stack[side][i].count_at_start : 0;
}

void __stdcall combatManagerDoVictory(HiHook* h, CombatManager* combatMgr, int winningGroup)
{
   for (int side = ATTACKER; side <= DEFENDER; ++side)
      for (int i = 0; i < 21; ++i)
		 combatMgr->stack[side][i].count_at_start = origNumTroops[side][i];

   CALL_2(int, __thiscall, h->GetDefaultFunc(), combatMgr, winningGroup);
}

double army::ComputeAttackerDamageReduction(army* defender, bool is_shooting)
{
   int attack = get_adjusted_attack(defender, is_shooting);
   int defense = defender->get_adjusted_defense(this, true);

   double mod = defense > attack ? min(1.0 - (defense - attack) * 0.025, 0.3) : 1.0;
   
   if (this->armyType == eCreaturePsychicElemental && defender->sMonInfo.attributes & CF_IMMUNE_TO_MIND_SPELLS)
      mod *= 0.5;

   if (this->armyType == eCreatureMagicElemental &&
	  (defender->armyType == eCreatureMagicElemental || defender->armyType == eCreatureBlackDragon))
      mod *= 0.5;

   if (is_shooting)
   {
	  int hex = this->gridIndex; 
      if (this->sMonInfo.attributes & CF_DOUBLE_WIDE)
		 hex += this->facing ? 1 : -1;

	  if (pCombatManager->hasObstaclePenalty(this, hex, defender->gridIndex))
         mod *= 0.5;

      if (pCombatManager->hasDistancePenalty(this, defender))
         mod *= 0.5;
   }

   if (this->sMonInfo.attributes & CF_SHOOTING_ARMY && !is_shooting && !(sMonInfo.attributes & CF_NO_MELEE_PENALTY))
      mod *= 0.5;

   // Effects
   bool blinded = this->residualBlindness;
   bool paralyzed = this->residualParalyze;
   int blindRetalMod = (int)(this->blindFactor * 100);
   int paralyzeRetalMod = o_Spell[SPELL_PARALYZE].effect[eMasteryAdvanced];

   int effectMod = 100;

   if (blinded && blindRetalMod < effectMod)
      effectMod = blindRetalMod;

   if (paralyzed && paralyzeRetalMod < effectMod)
      effectMod = paralyzeRetalMod;
   
   if (spellInfluence[SPELL_FEAR])
   {
	  int schoolLevel = activeSpellMastery[this->group][this->index][SPELL_FEAR];
      if (fearSpellParams[schoolLevel].retalDamageMod < effectMod)
         effectMod = fearSpellParams[schoolLevel].retalDamageMod;
   }

   mod = mod * effectMod / 100;
   return mod;
}

double __fastcall ComputeAttackerDamageReduction(army* attacker, int unused_edx, army* defender, bool isRangedAttack)
{
   return attacker->ComputeAttackerDamageReduction(defender, isRangedAttack);   
}

bool isRealArmy(army* Army)
{
   return Army == (army*)&pCombatManager->stack[Army->group][Army->index];
}

int __stdcall newRoundSpellSettings(LoHook* h, HookContext* c)
{
   c->return_address = 0x447033;
   army* Army = (army*)c->esi;

   // Explosion
   if (explosionSpeedReduction && explosionSpell[Army->group][Army->index].speedPenalty)
   {
	  explosionSpell[Army->group][Army->index].speedPenalty = false;
	  ++Army->sMonInfo.speed;
   }

   // Fear
   if (Army->spellInfluence[SPELL_FEAR] && activeSpellMastery[Army->group][Army->index][SPELL_FEAR] == eMasteryExpert)
      Army->retaliationCount = 0;
   
   // Poison
   if (Army->spellInfluence[SPELL_POISON])
   {
      int schoolLevel = activeSpellMastery[Army->group][Army->index][SPELL_POISON];
	  float healthMul = max(Army->poison_penalty - poisonSpellParams[schoolLevel].healthMod, poisonSpellParams[schoolLevel].minHealth);
	  Army->poison_penalty = healthMul;

      double fullHealth = (double)Army->origHitPoints * healthMul;

      // Poison, Age & Toughness
      if (Army->spellInfluence[SPELL_AGE])
         fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

	  if (Army->spellInfluence[SPELL_TOUGHNESS])
		 fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

	  if (Army->spellInfluence[SPELL_HOUR_OF_POWER])
		 fullHealth *= hourOfPowerSpell[Army->group][Army->index].healthMod / 100.0;

      int health = (int)(fullHealth + 0.95);

	  bool needPoisonAnim = Army->sMonInfo.hitPoints > health;
      if (needPoisonAnim)
		 c->return_address = 0x446FCB;

	  Army->sMonInfo.hitPoints = health;

      if (health - 1 < Army->residualDamage)
         Army->residualDamage = health - 1;
   }
      
   return NO_EXEC_DEFAULT;
}

int __stdcall applySpell(LoHook* h, HookContext* c)
{
   int spell = *(int*)(c->ebp + 8);
   int newSpellMastery = *(int*)(c->ebp + 0x10);
   hero* Hero = *(hero**)(c->ebp + 0x14);
   army* Army = (army*)c->esi;
   int schoolLevel = c->eax;
   int spellSpecialtyEffect = 0;

   switch (spell)
   {
   case SPELL_FEAR:
      if (!(Army->sMonInfo.attributes & CF_SIEGE_WEAPON))
      {
         fearSpell[Army->group][Army->index].speedMod = o_Spell[SPELL_FEAR].effect[schoolLevel];

         if (schoolLevel == eMasteryExpert)
         {
            Army->CancelIndividualSpell(SPELL_COUNTERSTRIKE);
            Army->retaliationCount = 0;
         }

         int minSpeedMod = 100;

         if (Army->spellInfluence[SPELL_SLOW] && slowSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = slowSpell[Army->group][Army->index].speedMod;

         if (Army->spellInfluence[SPELL_DISEASE] && diseaseSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = diseaseSpell[Army->group][Army->index].speedMod;

         if (fearSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = fearSpell[Army->group][Army->index].speedMod;
               
		 Army->slowPenalty = minSpeedMod / 100.0f;
      }

      break;

   case SPELL_POISON:
      {
         float healthMod = poisonSpellParams[schoolLevel].healthModFirstRound;
		 float healthMul = max(Army->poison_penalty - healthMod, poisonSpellParams[schoolLevel].minHealth);
		 Army->poison_penalty = healthMul;

         double fullHealth = (double)Army->origHitPoints * healthMul;

         // Poison, Age & Toughness
         if (Army->spellInfluence[SPELL_AGE])
            fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_HOUR_OF_POWER])
			fullHealth *= hourOfPowerSpell[Army->group][Army->index].healthMod / 100.0;

         int health = (int)(fullHealth + 0.95);

		 Army->sMonInfo.hitPoints = health;
         
         if (health - 1 < Army->residualDamage)
            Army->residualDamage = health - 1;
      }
      
	  break;

   case SPELL_DISEASE:
      {
         // Init
         diseaseSpell[Army->group][Army->index].attackPenalty = diseaseSpellParams[schoolLevel].attackPenalty;
         diseaseSpell[Army->group][Army->index].defensePenalty = diseaseSpellParams[schoolLevel].defensePenalty;

         // Optional, as we don't have heroes with Disease spell specialty yet
         if (Hero)
         {
			spellSpecialtyEffect = Hero->GetHeroSpellBonus(SPELL_DISEASE, Army->sMonInfo.level, o_Spell[SPELL_DISEASE].effect[newSpellMastery]);
            diseaseSpell[Army->group][Army->index].attackPenalty += spellSpecialtyEffect;
            diseaseSpell[Army->group][Army->index].defensePenalty += spellSpecialtyEffect;
         }

		 Army->sMonInfo.attackSkill -= diseaseSpell[Army->group][Army->index].attackPenalty;
         Army->sMonInfo.defenseSkill -= diseaseSpell[Army->group][Army->index].defensePenalty;

         // Not allowing attack and defense to drop below 0
         if (Army->sMonInfo.attackSkill < 0)
         {
            diseaseSpell[Army->group][Army->index].attackPenalty += Army->sMonInfo.attackSkill;
            Army->sMonInfo.attackSkill = 0;
         }

         if (Army->sMonInfo.defenseSkill < 0)
         {
            diseaseSpell[Army->group][Army->index].defensePenalty += Army->sMonInfo.defenseSkill;
            Army->sMonInfo.defenseSkill = 0;
         }

         if (!(Army->sMonInfo.attributes & CF_SIEGE_WEAPON))
         {
            diseaseSpell[Army->group][Army->index].speedMod =
               o_Spell[SPELL_DISEASE].effect[schoolLevel] + spellSpecialtyEffect;

            int minSpeedMod = 100;

            if (Army->spellInfluence[SPELL_SLOW] && slowSpell[Army->group][Army->index].speedMod < minSpeedMod)
               minSpeedMod = slowSpell[Army->group][Army->index].speedMod;

            if (Army->spellInfluence[SPELL_FEAR] && fearSpell[Army->group][Army->index].speedMod < minSpeedMod)
               minSpeedMod = fearSpell[Army->group][Army->index].speedMod;

            if (diseaseSpell[Army->group][Army->index].speedMod < minSpeedMod)
               minSpeedMod = diseaseSpell[Army->group][Army->index].speedMod;
               
			Army->slowPenalty = minSpeedMod / 100.0f;
         }
      }
      
	  break;

   case SPELL_SLOW:
      if (!(Army->sMonInfo.attributes & CF_SIEGE_WEAPON))
      {
         Army->CancelIndividualSpell(SPELL_HASTE);
         slowSpell[Army->group][Army->index].speedMod = *(int*)(c->ebp + 0x10);

         int minSpeedMod = 100;

         if (Army->spellInfluence[SPELL_FEAR] && fearSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = fearSpell[Army->group][Army->index].speedMod;

         if (Army->spellInfluence[SPELL_DISEASE] && diseaseSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = diseaseSpell[Army->group][Army->index].speedMod;

         if (slowSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = slowSpell[Army->group][Army->index].speedMod;
               
		 Army->slowPenalty = minSpeedMod / 100.0f;

         // Slow animation
		 Army->sMonFrameInfo.iWalkCycleTime = (int)(Army->origWalkCycleTime * 1.5);
      }
      
	  break;

   case SPELL_AGE:
      {
		 float healthMul = Army->poison_penalty;
         int ageHealthMod = min(o_Spell[SPELL_AGE].effect[schoolLevel], ageSpell[Army->group][Army->index].healthMod);
         ageSpell[Army->group][Army->index].healthMod = ageHealthMod;

         double fullHealth = (double)Army->origHitPoints * healthMul * ageHealthMod / 100.0;
         
		 if (Army->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_HOUR_OF_POWER])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;
		 
		 int health = (int)(fullHealth + 0.95);

         Army->sMonInfo.hitPoints = health;

         if (health - 1 < Army->residualDamage)
            Army->residualDamage = health - 1;
      }
      
	  break;

   case SPELL_DEATH_BLOW:
      break;

   case SPELL_DRAIN_LIFE:
      break;

   case SPELL_TOUGHNESS:
      {
		 float healthMul = Army->poison_penalty;
		 int toughnessHealthMod = o_Spell[SPELL_TOUGHNESS].effect[schoolLevel];
		 toughnessSpell[Army->group][Army->index].healthMod = toughnessHealthMod;

		 double fullHealth = (double)Army->origHitPoints * healthMul * toughnessHealthMod / 100.0;
		 
		 if (Army->spellInfluence[SPELL_AGE])
			fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_HOUR_OF_POWER])
			fullHealth *= hourOfPowerSpell[Army->group][Army->index].healthMod / 100.0;

         int health = (int)(fullHealth + 0.95);

         Army->sMonInfo.hitPoints = health;

         if (health - 1 < Army->residualDamage)
            Army->residualDamage = health - 1;
      }
      
	  break;

   case SPELL_BEHEMOTHS_CLAWS:
	  break;

   case SPELL_HOUR_OF_POWER:
	  Army->CancelIndividualSpell(SPELL_CURSE);
	  Army->CancelIndividualSpell(SPELL_BLESS);
	  Army->CancelIndividualSpell(SPELL_BLOODLUST);
	  Army->CancelIndividualSpell(SPELL_MISFORTUNE);
	  Army->CancelIndividualSpell(SPELL_FORTUNE);
	  Army->CancelIndividualSpell(SPELL_SLAYER);

	  Army->blessFactor = o_Spell[SPELL_BLESS].effect[eMasteryExpert];

	  Army->bloodlustBonus = o_Spell[SPELL_BLOODLUST].effect[eMasteryExpert];
	  if (Hero)
	  {
		 spellSpecialtyEffect = Hero->GetHeroSpellBonus(SPELL_BLOODLUST, Army->sMonInfo.level, o_Spell[SPELL_BLOODLUST].effect[eMasteryExpert]);
		 Army->bloodlustBonus += spellSpecialtyEffect;
	  }

	  Army->fortuneBonus = o_Spell[SPELL_FORTUNE].effect[eMasteryExpert];
	  if (Hero)
	  {
		 spellSpecialtyEffect = Hero->GetHeroSpellBonus(SPELL_FORTUNE, Army->sMonInfo.level, o_Spell[SPELL_FORTUNE].effect[eMasteryExpert]);
		 Army->fortuneBonus += spellSpecialtyEffect;
	  }

	  Army->slayerLevel = eMasteryExpert;

	  {
		 float healthMul = Army->poison_penalty;
		 int hourOfPowerHealthMod = o_Spell[SPELL_HOUR_OF_POWER].effect[schoolLevel];
		 hourOfPowerSpell[Army->group][Army->index].healthMod = hourOfPowerHealthMod;

		 double fullHealth = (double)Army->origHitPoints * healthMul * hourOfPowerHealthMod / 100.0;

		 if (Army->spellInfluence[SPELL_AGE])
			fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

		 int health = (int)(fullHealth + 0.95);

		 Army->sMonInfo.hitPoints = health;

		 if (health - 1 < Army->residualDamage)
			Army->residualDamage = health - 1;
	  }

	  break;

   default:
      return EXEC_DEFAULT;
   }

   // Force Capped Duration
   if (forceCappedDuration[spell])
	  Army->spellInfluence[spell] = min(forceCappedDuration[spell], Army->spellInfluence[spell]);
   
   c->return_address = 0x444D5C;
   return NO_EXEC_DEFAULT;
}

int __stdcall resetSpell(LoHook* h, HookContext* c)
{
   int spell = *(int*)(c->ebp + 8);
   army* Army = (army*)c->esi;

   switch (spell)
   {
   case SPELL_FEAR:
      if (!(Army->sMonInfo.attributes & CF_SIEGE_WEAPON))
      {
         int minSpeedMod = 100;

         if (Army->spellInfluence[SPELL_SLOW] && slowSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = slowSpell[Army->group][Army->index].speedMod;

         if (Army->spellInfluence[SPELL_DISEASE] && diseaseSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = diseaseSpell[Army->group][Army->index].speedMod;

		 Army->slowPenalty = minSpeedMod / 100.0f;
      }

	  if (isRealArmy(Army))
		 fearSpell[Army->group][Army->index].speedMod = 100;
      
	  break;

   case SPELL_POISON:
      {
		 Army->poison_penalty = 1.0f;
         double fullHealth = (double)Army->origHitPoints;

         // Poison, Age & Toughness
         if (Army->spellInfluence[SPELL_AGE])
            fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_HOUR_OF_POWER])
			fullHealth *= hourOfPowerSpell[Army->group][Army->index].healthMod / 100.0;

         int health = (int)(fullHealth + 0.95);

         Army->sMonInfo.hitPoints = health;

         if (health - 1 < Army->residualDamage)
            Army->residualDamage = health - 1;
      }
      break;

   case SPELL_DISEASE:
      Army->sMonInfo.attackSkill += diseaseSpell[Army->group][Army->index].attackPenalty;
      Army->sMonInfo.defenseSkill += diseaseSpell[Army->group][Army->index].defensePenalty;

      if (!(Army->sMonInfo.attributes & CF_SIEGE_WEAPON))
      {
         int minSpeedMod = 100;

         if (Army->spellInfluence[SPELL_SLOW] && slowSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = slowSpell[Army->group][Army->index].speedMod;

         if (Army->spellInfluence[SPELL_FEAR] && fearSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = fearSpell[Army->group][Army->index].speedMod;

		 Army->slowPenalty = minSpeedMod / 100.0f;
      }
      
	  if (isRealArmy(Army))
		 diseaseSpell[Army->group][Army->index].speedMod = 100;

      break;
   
   case SPELL_SLOW:
      if (!(Army->sMonInfo.attributes & CF_SIEGE_WEAPON))
      {
         int minSpeedMod = 100;

         if (Army->spellInfluence[SPELL_FEAR] && fearSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = fearSpell[Army->group][Army->index].speedMod;

         if (Army->spellInfluence[SPELL_DISEASE] && diseaseSpell[Army->group][Army->index].speedMod < minSpeedMod)
            minSpeedMod = diseaseSpell[Army->group][Army->index].speedMod;

		 Army->slowPenalty = minSpeedMod / 100.0f;
      }

      // Slow animation
	  Army->sMonFrameInfo.iWalkCycleTime = Army->origWalkCycleTime; 

      if (isRealArmy(Army))
		 slowSpell[Army->group][Army->index].speedMod = 100;

      break;

   case SPELL_AGE:
      {
		 float healthMul = Army->poison_penalty;
         
		 if (isRealArmy(Army))
			ageSpell[Army->group][Army->index].healthMod = 100;

         double fullHealth = (double)Army->origHitPoints * healthMul;
		 
		 if (Army->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_HOUR_OF_POWER])
			fullHealth *= hourOfPowerSpell[Army->group][Army->index].healthMod / 100.0;

         int health = (int)(fullHealth + 0.95);

         Army->sMonInfo.hitPoints = health;

         if (health - 1 < Army->residualDamage)
            Army->residualDamage = health - 1;
      }
      break;

   case SPELL_DEATH_BLOW:
      break;

   case SPELL_DRAIN_LIFE:
      break;

   case SPELL_TOUGHNESS:
      {
		 float healthMul = Army->poison_penalty;
         
		 if (isRealArmy(Army))
			toughnessSpell[Army->group][Army->index].healthMod = 100;

         double fullHealth = (double)Army->origHitPoints * healthMul;
		 
		 if (Army->spellInfluence[SPELL_AGE])
			fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_HOUR_OF_POWER])
			fullHealth *= hourOfPowerSpell[Army->group][Army->index].healthMod / 100.0;

         int health = (int)(fullHealth + 0.95);

         Army->sMonInfo.hitPoints = health;

         if (health - 1 < Army->residualDamage)
            Army->residualDamage = health - 1;
      }
      break;

   case SPELL_BEHEMOTHS_CLAWS:
	  break;


   case SPELL_HOUR_OF_POWER:
	  {
		 float healthMul = Army->poison_penalty;
         
		 if (isRealArmy(Army))
			hourOfPowerSpell[Army->group][Army->index].healthMod = 100;

         double fullHealth = (double)Army->origHitPoints * healthMul;
		 
		 if (Army->spellInfluence[SPELL_AGE])
			fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

		 if (Army->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

         int health = (int)(fullHealth + 0.95);

         Army->sMonInfo.hitPoints = health;

         if (health - 1 < Army->residualDamage)
            Army->residualDamage = health - 1;
      }
	  break;

   default:
      return EXEC_DEFAULT;
   }

   c->return_address = 0x4444E1;
   return NO_EXEC_DEFAULT;
}

int __stdcall creatureCast(LoHook* h, HookContext* c)
{
   int spell = c->eax;
   int hex_ix = *(int*)(c->esi - 0xB4);

   switch (spell)
   {
   case SPELL_POISON:
   case SPELL_DISEASE:
	  pCombatManager->CastSpell(spell, hex_ix, 1, -1, eMasteryNone, 3); 
      break;
   case SPELL_AGE:
	  pCombatManager->CastSpell(spell, hex_ix, 1, -1, eMasteryExpert, 3); 
      break;
   default:
      return EXEC_DEFAULT;
   }
   
   c->return_address = 0x468CE7;
   return NO_EXEC_DEFAULT;
}


int __stdcall zombieDiseaseOnMagicPlains(LoHook* h, HookContext* c)
{
   int spell = *(int*)(c->ebp + 8);
   
   if (pCombatManager->Field<int>(0x53C0) == 1 && spell == SPELL_DISEASE)
   {
      c->esi = 1;
      *(int*)(c->ebp - 0x44) = 1;
   }
      
   return EXEC_DEFAULT;
}

int __stdcall cureNewSpells(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;

   Army->CancelIndividualSpell(SPELL_FEAR);
   
   return EXEC_DEFAULT;
}

bool isDrainLifeImmune(int unitType)
{
   switch (unitType)
   {
   case eCreatureStoneGargoyle:
   case eCreatureObsidianGargoyle:
   case eCreatureStoneGolem:
   case eCreatureIronGolem:
   case eCreatureGoldGolem:
   case eCreatureDiamondGolem:
   case eCreatureGiant:
   case eCreatureTitan:
   case eCreatureVampireLord:
   case eCreatureAirElemental:
   case eCreatureStormElemental:
   case eCreatureEarthElemental:
   case eCreatureMagmaElemental:
   case eCreatureFireElemental:
   case eCreatureEnergyElemental:
   case eCreatureWaterElemental:
   case eCreatureIceElemental:
   case eCreaturePsychicElemental:
   case eCreatureMagicElemental:
      return true;
   default:
      return false;
   }
}

bool isSupportiveUnitNotBallista(int unitType)
{
   return unitType == eCreatureCatapult || unitType == eCreatureFirstAidTent || unitType == eCreatureAmmoCart;
}

int __stdcall getStackMagicVulnerability(LoHook* h, HookContext* c)
{
   _CreatureInfo_* unit = (_CreatureInfo_*)c->edi;
   int unitType = *(int*)(c->ebp - 8);
   int spell = *(int*)(c->ebp - 0x10);

   bool immune = false; 

   switch (spell)
   {
   // Let's allow to cast Disease on battle machines
   case SPELL_DISEASE:
      if (!(unit->flags & CF_ALIVE) && !(unit->flags & CF_SIEGE_WEAPON))
         immune = true;
      break;
   case SPELL_AGE:
      if (!(unit->flags & CF_ALIVE))
         immune = true;
      break;
   case SPELL_FEAR:
      if (!(unit->flags & CF_ALIVE))
         immune = true;
      break;
   case SPELL_DEATH_CLOUD_NEW:
	  if (unit->flags & CF_UNDEAD)
		 immune = true;
	  break;
   case SPELL_DEATH_BLOW:
      break;
   case SPELL_DRAIN_LIFE:
      if (isDrainLifeImmune(unitType))
         immune = true;
      break;
   case SPELL_BEHEMOTHS_CLAWS:
	  if (unitType == eCreatureAncientBehemoth)
		 immune = true;
	  break;
   case SPELL_HOUR_OF_POWER:
	  if (unit->flags & CF_UNDEAD)
		 immune = true;
	  break;
   case SPELL_BLESS:
	  if (unit->flags & CF_UNDEAD)
		 immune = true;
	  break;

   default:
      return EXEC_DEFAULT;
   }

   c->return_address = immune ? 0x44A3E8 : 0x44A416;
   return NO_EXEC_DEFAULT;
}

int hero::getBestMagicSchoolForSpell(SpellID spell)
{
   int magicSchoolSecSkill = HSS_EARTH_MAGIC;
   int maxExpertise = this->SSLevel[HSS_EARTH_MAGIC];
   
   if (o_Spell[spell].flags & SSF_AIR && this->SSLevel[HSS_AIR_MAGIC] > maxExpertise)
   {
	  maxExpertise = this->SSLevel[HSS_AIR_MAGIC];
	  magicSchoolSecSkill = HSS_AIR_MAGIC;
   }

   if (o_Spell[spell].flags & SSF_FIRE && this->SSLevel[HSS_FIRE_MAGIC] > maxExpertise)
   {
	  maxExpertise = this->SSLevel[HSS_FIRE_MAGIC];
	  magicSchoolSecSkill = HSS_FIRE_MAGIC;
   }

   if (o_Spell[spell].flags & SSF_WATER && this->SSLevel[HSS_WATER_MAGIC] > maxExpertise)
   {
	  maxExpertise = this->SSLevel[HSS_WATER_MAGIC];
	  magicSchoolSecSkill = HSS_WATER_MAGIC;
   }

   return magicSchoolSecSkill;
}

// ===============================================================
// ---- Summon Sprite, Summon Magic Elemental, Summon Firebird ---
// ---------------------------------------------------------------
int __fastcall get_elemental_type(enum SpellID spell)
{
   int unitType;

   switch (spell)
   {
   case SPELL_SUMMON_FIRE_ELEMENTAL:
      unitType = eCreatureFireElemental;
      break;
   case SPELL_SUMMON_EARTH_ELEMENTAL:
      unitType = eCreatureEarthElemental;
      break;
   case SPELL_SUMMON_WATER_ELEMENTAL:
      unitType = eCreatureWaterElemental;
      break;
   case SPELL_SUMMON_AIR_ELEMENTAL:
      unitType = eCreatureAirElemental;
      break;
   case SPELL_SUMMON_SPRITE:
      unitType = eCreatureSprite;
      break;
   case SPELL_SUMMON_MAGIC_ELEMENTAL:
      unitType = eCreatureMagicElemental;
      break;
   case SPELL_SUMMON_FIREBIRD:
      unitType = eCreatureFirebird;
      break;
   default:
      unitType = ID_NONE;
   }

   return unitType;
}

double getSummoningEffect(enum SpellID spell, int schoolLevel)
{
   double effect = 0.0;
   double elem_AI_Value_Avg = (o_pCreatureInfo[eCreatureAirElemental].AI_value + o_pCreatureInfo[eCreatureEarthElemental].AI_value +
      o_pCreatureInfo[eCreatureFireElemental].AI_value + o_pCreatureInfo[eCreatureWaterElemental].AI_value) / 4.0;

   switch (spell)
   {
   case SPELL_SUMMON_FIRE_ELEMENTAL:
   case SPELL_SUMMON_EARTH_ELEMENTAL:
   case SPELL_SUMMON_WATER_ELEMENTAL:
   case SPELL_SUMMON_AIR_ELEMENTAL:
      effect = 1;
      break;
   case SPELL_SUMMON_SPRITE:
      effect = 0.8 * elem_AI_Value_Avg / o_pCreatureInfo[eCreatureSprite].AI_value;
      break;
   case SPELL_SUMMON_MAGIC_ELEMENTAL:
      effect = 1.2 * elem_AI_Value_Avg / o_pCreatureInfo[eCreatureMagicElemental].AI_value;
      break;
   case SPELL_SUMMON_FIREBIRD:
      effect = 1.2 * elem_AI_Value_Avg / o_pCreatureInfo[eCreatureFirebird].AI_value;
      break;
   }

   effect *= o_Spell[spell].effect[schoolLevel];

   return effect;
}

bool CombatManager::AbleToSummonElemental(SpellID spell, long side)
{
   if (stacks_count[side] >= 20)
	  return false;

   int unitType = PField<int>(0x132A8)[side];
   if (unitType == ID_NONE)
      return true;

   bool result;

   switch (spell)
   {
   case SPELL_SUMMON_FIRE_ELEMENTAL:
      result = unitType == eCreatureFireElemental;
      break;
   case SPELL_SUMMON_EARTH_ELEMENTAL:
      result = unitType == eCreatureEarthElemental;
      break;
   case SPELL_SUMMON_WATER_ELEMENTAL:
      result = unitType == eCreatureWaterElemental;
      break;
   case SPELL_SUMMON_AIR_ELEMENTAL:
      result = unitType == eCreatureAirElemental;
      break;
   case SPELL_SUMMON_SPRITE:
      result = unitType == eCreatureSprite;
      break;
   case SPELL_SUMMON_MAGIC_ELEMENTAL:
      result = unitType == eCreatureMagicElemental;
      break;
   case SPELL_SUMMON_FIREBIRD:
      result = unitType == eCreatureFirebird;
      break;
   default:
      result = unitType == ID_NONE;
   }

   return result;
}

bool __fastcall AbleToSummonElemental(CombatManager* combatMgr, int unused_edx, enum SpellID spell, int side)
{
   return combatMgr->AbleToSummonElemental(spell, side);   
}

int __stdcall SummonCreatures(LoHook* h, HookContext* c)
{
   int spell = *(int*)(c->ebp + 8);
   int unitType;

   switch (spell)
   {
   case SPELL_SUMMON_SPRITE:
      unitType = eCreatureSprite;
      break;
   case SPELL_SUMMON_MAGIC_ELEMENTAL:
      unitType = eCreatureMagicElemental;
      break;
   case SPELL_SUMMON_FIREBIRD:
      unitType = eCreatureFirebird;
      break;
   default:
      return EXEC_DEFAULT;
   }

   CALL_5(void, __thiscall, 0x5A7390, pCombatManager, spell, unitType, *(int*)(c->ebp + 0x1C), c->esi);

   c->return_address = 0x5A2368;
   return NO_EXEC_DEFAULT;
}

int __stdcall skipNonElementals(LoHook* h, HookContext* c)
{
   int unitType = *(int*)(c->ebp + 0xC);
   
   switch (unitType)
   {
   case eCreatureSprite:
   case eCreatureFirebird:
      c->return_address = 0x5A74DD;
      return NO_EXEC_DEFAULT;
   default:
      return EXEC_DEFAULT;
   }
}

int spriteSpellParams[] = {1000, 1000, 1500, 2000};
int magicElementalSpellParams[] = {100, 100, 150, 200};
int firebirdSpellParams[] = {50, 50, 75, 100};

int __stdcall setSummonedCreaturesNumber(LoHook* h, HookContext* c)
{
   int unitType = *(int*)(c->ebp + 0xC);
   int spellPower = *(int*)(c->ebp + 0x10);
   int schoolLevel = *(int*)(c->ebp + 0x14);

   switch (unitType)
   {
   case eCreatureSprite:
      c->esi = spriteSpellParams[schoolLevel];
      break;
   case eCreatureMagicElemental:
      c->esi = magicElementalSpellParams[schoolLevel];
      break;
   case eCreatureFirebird:
      c->esi = firebirdSpellParams[schoolLevel];
      break;
   default:
      return EXEC_DEFAULT;
   }

   c->esi = c->esi * spellPower / 100;
   if (c->esi < 1) c->esi = 1;
   
   c->ecx = c->ebx;
   c->return_address = 0x5A7526;
   return NO_EXEC_DEFAULT;
}

int __stdcall checkSummonedCreaturesType(LoHook* h, HookContext* c)
{
   c->return_address = 0x59F8B7;
   int spell = c->ebx;
     
   switch (spell)
   {
   case SPELL_SUMMON_SPRITE:
   case SPELL_SUMMON_FIREBIRD:
      c->return_address = 0x59F8C0;
      break;
   case SPELL_SUMMON_FIRE_ELEMENTAL:
      c->eax = eCreatureFireElemental;
      break;
   case SPELL_SUMMON_EARTH_ELEMENTAL:
      c->eax = eCreatureEarthElemental;
      break;
   case SPELL_SUMMON_WATER_ELEMENTAL:
      c->eax = eCreatureWaterElemental;
      break;
   case SPELL_SUMMON_AIR_ELEMENTAL:
      c->eax = eCreatureAirElemental;
      break;
   case SPELL_SUMMON_MAGIC_ELEMENTAL:
      c->eax = eCreatureMagicElemental;
      break;
   default:
      c->eax = ID_NONE;
   }
      
   return NO_EXEC_DEFAULT;
}

int __stdcall setOrigNumTroops(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ebx;

   if (Army)
	  origNumTroops[Army->group][Army->index] = Army->origNumTroops;

   return EXEC_DEFAULT;
}
// ===============================================================

// ===============================================================
// --------------------- AI Spell Weighting ----------------------
// ---------------------------------------------------------------

// Debug
#ifdef NEWSPELLS_DEBUG
void showSpellInfo(SpellID spell, const type_AI_spellcaster* const caster, army* const Army1, army* const Army2, type_enchant_data data, int valueParam, int value)
{
   debugStr("{%s} evaluates {%s}\n\n{%d} %s\n{%d} %s\n\nskillMastery = {%d}\nspellDuration = {%d}\nlowest_attack = {%d}\nlowest_defense = {%d}\n\n" \
	  "valueParam = {%d}\nvalue = {%d}",
	  caster->current_hero ? caster->current_hero->name : "Army",
	  o_Spell[spell].name,
	  Army1->numTroops,
	  Army1->numTroops > 1 ? Army1->sMonInfo.m_plural_name : Army1->sMonInfo.m_name,
	  Army2 ? Army2->numTroops : 0,
	  Army2 ? (Army2->numTroops > 1 ? Army2->sMonInfo.m_plural_name : Army2->sMonInfo.m_name) : 0,
	  data.mastery,
	  data.duration,
	  caster->estimate.lowest_attack,
	  caster->estimate.lowest_defense,
	  valueParam,
	  value);
}
#endif

// Anti-Magic
int type_AI_spellcaster::get_antimagic_cancel_value(army* current_army, TSkillMastery mastery) const
{
   int spellValueSum = 0;
   int dispelLevel;
   type_enchant_data enchantData;

   switch (mastery) {
	  case eMasteryAdvanced:
		 dispelLevel = 4;
		 break;
	  case eMasteryExpert:
		 dispelLevel = 5;
		 break;
	  default:
		dispelLevel = 3;
   }
   
   for (int iSpell = SPELL_SHIELD; iSpell < SPELLS_NUM; ++iSpell)
   {
	  int (__thiscall type_AI_spellcaster::*value_func)(army* const, type_enchant_data) const = this->get_enchantment_function((SpellID)iSpell);
	  	  
	  if (current_army->spellInfluence[iSpell] && value_func && dispelLevel >= o_Spell[iSpell].level)
	  {
		 enchantData.spell = (SpellID)iSpell;
		 enchantData.check_resistance = 0;
		 enchantData.mastery = (TSkillMastery)activeSpellMastery[current_army->group][current_army->index][iSpell];
		 enchantData.power = current_army->spellInfluence[iSpell];
		 enchantData.duration = current_army->spellInfluence[iSpell];
		 
		 current_army->CancelIndividualSpell(iSpell);
		 if (o_Spell[iSpell].type < 0 == (current_army->group == this->our_group))
			spellValueSum += (this->enemy_caster->*value_func)(current_army, enchantData);
		 /*else
			spellValueSum -= (this->*value_func)(current_army, enchantData);*/
	  }
   }
   
   return spellValueSum;
}

int type_AI_spellcaster::get_antimagic_value(army* const Army, type_enchant_data data) const
{
   army* current_army = new army;
   current_army->copyConstructor(Army);

   int cancelValue = get_antimagic_cancel_value(current_army, data.mastery);
   
   delete current_army;

   return cancelValue + get_protection_value(Army, eSchoolAll, o_Spell[SPELL_ANTI_MAGIC].effect[data.mastery], data.duration, 0);
}

// Poison
int type_AI_spellcaster::get_poison_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int valueParam = 0;

   if (!Army->spellInfluence[SPELL_POISON] && !this->win_likely)
   {
	  float workChance = pCombatManager->SpellCastWorkChance(SPELL_POISON, this->our_group, Army, false, true, this->is_creature_spell);
	  if (workChance > 0.0f)
	  {
		 army* dummyArmy = new army;
		 dummyArmy->copyConstructor(Army);

		 int healthBefore = dummyArmy->currentHealth();
         
		 // First round
		 float healthMod = poisonSpellParams[data.mastery].healthModFirstRound;
		 float healthMul = max(dummyArmy->poison_penalty - healthMod, poisonSpellParams[data.mastery].minHealth);
		 dummyArmy->poison_penalty = healthMul;
		 double fullHealth = (double)dummyArmy->origHitPoints * healthMul;

		 // Poison, Age & Toughness
		 if (dummyArmy->spellInfluence[SPELL_AGE])
			fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

		 if (dummyArmy->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

		 int health = (int)(fullHealth + 0.95);

		 dummyArmy->sMonInfo.hitPoints = health;
         
		 if (health - 1 < dummyArmy->residualDamage)
			dummyArmy->residualDamage = health - 1;

		 int healthAfter = dummyArmy->currentHealth();
		 int damage = healthBefore - healthAfter;
         
		 // Next 2 rounds
		 for (int i = 1; i < (int)max(data.duration, 3); ++i)
		 {
			if (dummyArmy->spellInfluence[SPELL_AGE] <= i)
			   dummyArmy->CancelIndividualSpell(SPELL_AGE);

			if (dummyArmy->spellInfluence[SPELL_TOUGHNESS] <= i)
			   dummyArmy->CancelIndividualSpell(SPELL_TOUGHNESS);

			healthBefore = dummyArmy->currentHealth();
      	  
			healthMod = poisonSpellParams[data.mastery].healthMod;
			healthMul = max(dummyArmy->poison_penalty - healthMod, poisonSpellParams[data.mastery].minHealth);
			dummyArmy->poison_penalty = healthMul;
			fullHealth = (double)dummyArmy->origHitPoints * healthMul;

			// Poison, Age & Toughness
			if (dummyArmy->spellInfluence[SPELL_AGE] > i)
			   fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;

			if (dummyArmy->spellInfluence[SPELL_TOUGHNESS] > i)
			   fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;

			health = (int)(fullHealth + 0.95);

			dummyArmy->sMonInfo.hitPoints = health;

			if (health - 1 < dummyArmy->residualDamage)
			   dummyArmy->residualDamage = health - 1;
      	  
			healthAfter = dummyArmy->currentHealth();
			damage += healthBefore - healthAfter;
		 }

		 delete dummyArmy;

		 int effectiveDamage = (int)(damage * workChance);
		 value = Army->get_loss_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense, Army->can_shoot(),
			effectiveDamage, this->estimate.kills_only);
		 valueParam = effectiveDamage;
	  }
   }

#ifdef NEWSPELLS_DEBUG   
   showSpellInfo(SPELL_POISON, this, Army, Army->AI_target, data, valueParam, value);
#endif

   return value;
}

// Disease
int type_AI_spellcaster::get_disease_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int totalCombatValue = 0;
   
   if (!Army->spellInfluence[SPELL_DISEASE] && Army->AI_target && Army->AI_target->numTroops && !this->win_likely)
   {
	  float workChance = pCombatManager->SpellCastWorkChance(SPELL_DISEASE, this->our_group, Army, false, true, this->is_creature_spell);
	  if (workChance > 0.0f)
	  {
		 int speed = Army->GetSpeed();
		 int targetTime = Army->get_AI_target_time(speed);
		 int rounds_left = this->estimate.rounds_left;

		 if (targetTime <= rounds_left)
		 {
			int spellDuration = data.duration;
   		 
			if (Army->sMonInfo.attributes & CF_DONE)
			   --spellDuration;

			if (spellDuration > 0)
			{
			   int adjSpeed = max(1, speed * o_Spell[SPELL_DISEASE].effect[data.mastery] / 100);

			   if (targetTime == 1)
			   {
				  for (int i = 0; i < pCombatManager->stacks_count[this->our_group]; ++i)
				  {
					 army* iArmy = (army*)&pCombatManager->stack[this->our_group][i];
   				  
					 if (iArmy->AI_target == Army &&
						!iArmy->spellInfluence[SPELL_BLIND] &&
						!iArmy->spellInfluence[SPELL_STONE_GAZE] &&
						!iArmy->spellInfluence[SPELL_PARALYZE] &&
						!(iArmy->sMonInfo.attributes & CF_IMMOBILIZED) &&
						iArmy->armyType != eCreatureFirstAidTent &&
						iArmy->armyType != eCreatureAmmoCart &&
						iArmy->GetSpeed() <= speed &&
						iArmy->GetSpeed() > adjSpeed)
					 {
						army* AI_target = iArmy->AI_target;
   					 
						if (AI_target)
						{
						   const type_AI_combat_parameters* estimate = &this->estimate;
						   int effect = estimate->get_exchange_effect(iArmy, AI_target) + estimate->get_exchange_effect(AI_target, iArmy);
						   if (effect > value)
							  value = effect;
						}
					 }
				  }
			   }

			   if (!Army->can_shoot())
			   {
				  int deltaTargetTime = min(spellDuration, Army->get_AI_target_time(adjSpeed) - targetTime);
   			   
				  if (deltaTargetTime > 0)
				  {
					 totalCombatValue = Army->get_total_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense);
					 int adjTargetTime = min(rounds_left, targetTime + deltaTargetTime);
					 // Weight of speed exchange
					 value += totalCombatValue * (adjTargetTime - targetTime) / rounds_left;
				  }
			   }

			   if (!this->estimate.kills_only)
			   {
				  // Weight of defense penalty
				  totalCombatValue = Army->get_total_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense);
				  value += (int)(totalCombatValue * (1.0 - sqrt(1.0 - diseaseSpellParams[data.mastery].defensePenalty * 0.05)));
   			   
				  // Weight of attack penalty
				  if ((1 << Army->index) & this->enemy_can_attack)
					 value += this->get_attack_skill_value(Army, Army->AI_target, spellDuration,
						min(Army->sMonInfo.attackSkill, diseaseSpellParams[data.mastery].attackPenalty));
			   }

			   value = (int)(value * workChance);
			}
		 }
	  }
   }

#ifdef NEWSPELLS_DEBUG   
   showSpellInfo(SPELL_DISEASE, this, Army, Army->AI_target, data, totalCombatValue, value);
#endif
   
   return value;
}

// Age
int type_AI_spellcaster::get_age_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int valueParam = 0;

   if (!Army->spellInfluence[SPELL_AGE] && !this->win_likely)
   {
	  float workChance = pCombatManager->SpellCastWorkChance(SPELL_AGE, this->our_group, Army, false, true, this->is_creature_spell);
	  if (workChance > 0.0f)
	  {
		 int healthBefore = Army->currentHealth();
            
		 float healthMul = Army->poison_penalty;
		 int ageHealthMod = min(o_Spell[SPELL_AGE].effect[data.mastery], ageSpell[Army->group][Army->index].healthMod);

		 double fullHealth = (double)Army->origHitPoints * healthMul * ageHealthMod / 100.0;

		 // Age & Toughness
		 if (Army->spellInfluence[SPELL_TOUGHNESS])
			fullHealth *= toughnessSpell[Army->group][Army->index].healthMod / 100.0;
       
		 int health = (int)(fullHealth + 0.95);

		 int healthAfter = health * Army->numTroops - (health - 1 < Army->residualDamage ? health - 1 : Army->residualDamage);
		 int effectiveDamage = (int)((healthBefore - healthAfter) * workChance);
         
		 value = Army->get_loss_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense, Army->can_shoot(),
			effectiveDamage, this->estimate.kills_only);
		 valueParam = effectiveDamage;
	  }
   }
   
#ifdef NEWSPELLS_DEBUG   
   showSpellInfo(SPELL_AGE, this, Army, Army->AI_target, data, valueParam, value);
#endif

   return value;
}

// Fear
int type_AI_spellcaster::get_fear_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int totalCombatValue = 0;

   if (!Army->spellInfluence[SPELL_FEAR] &&
	  !Army->spellInfluence[SPELL_BLIND] &&
	  !Army->spellInfluence[SPELL_STONE_GAZE] &&
	  !Army->spellInfluence[SPELL_PARALYZE] &&
	  !this->win_likely)
   {
	  float workChance = pCombatManager->SpellCastWorkChance(SPELL_FEAR, this->our_group, Army, false, true, this->is_creature_spell);
	  if (workChance > 0.0f && (1 << Army->index) & this->enemy_can_attack)
	  {
		 totalCombatValue = Army->get_total_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense);
		 int rounds_left = this->estimate.rounds_left;
		 if (totalCombatValue < this->estimate.awake_enemy_value)
		 {
			double durationRatio =
			   data.duration < rounds_left ? durationRatio = (double)data.duration / rounds_left : 1.0;

			if (Army->sMonInfo.attributes & CF_DONE)
			{
			   durationRatio -= 1.0 / rounds_left;

			   if (durationRatio < 0.0)
				  durationRatio = 0.0;
			}

			totalCombatValue = (int)(totalCombatValue * durationRatio);
		 }
		 else
			totalCombatValue = (int)(totalCombatValue * (0.5 - sqrt(fearSpellParams[data.mastery].retalDamageMod / 400.0)));

		 value = (int)((1.0 + min(data.duration, rounds_left) * 0.25) * totalCombatValue * workChance);
	  }
   }

#ifdef NEWSPELLS_DEBUG   
   showSpellInfo(SPELL_FEAR, this, Army, Army->AI_target, data, totalCombatValue, value);
#endif

   return value;
}

// Death Blow
int type_AI_spellcaster::get_death_blow_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int totalCombatValue = 0;

   if (!Army->spellInfluence[SPELL_DEATH_BLOW] && Army->AI_target && Army->AI_target->numTroops > 0 && !this->win_likely)
   {
	  army* targetArmy = new army;
	  targetArmy->copyConstructor(Army);

	  army* enemyArmy = new army;
	  enemyArmy->copyConstructor(Army->AI_target);

	  if (!targetArmy->can_shoot() && targetArmy->get_AI_target_time(targetArmy->GetSpeed()) == 1)
	  {
		 int savedSpellMastery = activeSpellMastery[targetArmy->group][targetArmy->index][SPELL_DEATH_BLOW];

		 int targetArmyHealth = targetArmy->get_total_hit_points();
		 int enemyArmyHealth = enemyArmy->get_total_hit_points();
		 int avgDamageBeforeAttack =
			(1 + o_Spell[SPELL_DEATH_BLOW].effect[data.mastery] / 100) * targetArmy->get_average_damage(enemyArmy, targetArmy->can_shoot(),
			(targetArmy->sMonInfo.hitPoints + targetArmyHealth - 1) / targetArmy->sMonInfo.hitPoints);

		 this->estimate.simulate_attack(targetArmy, targetArmyHealth, enemyArmy, enemyArmyHealth, targetArmy->can_shoot());
		 
		 if (targetArmyHealth > 0)
		 {
			int avgDamageAfterAttack =
			   (1 + o_Spell[SPELL_DEATH_BLOW].effect[data.mastery] / 100) * targetArmy->get_average_damage(enemyArmy, targetArmy->can_shoot(),
			   (targetArmy->sMonInfo.hitPoints + targetArmyHealth - 1) / targetArmy->sMonInfo.hitPoints);

			if (targetArmy->can_shoot() && targetArmy->sMonInfo.attributes & CF_TWO_ATTACKS)
			   avgDamageAfterAttack /= 2;

			double k = 1.0 + (double)avgDamageAfterAttack / avgDamageBeforeAttack;

			int avgDamage = targetArmy->get_average_damage(enemyArmy, targetArmy->can_shoot(), targetArmy->numTroops);
			int adjAvgDamage = (int)(k * avgDamage);
			targetArmyHealth = targetArmy->get_total_hit_points();

			if (adjAvgDamage > targetArmyHealth)
			{
			   adjAvgDamage = targetArmyHealth;
			   k = (double)targetArmyHealth / avgDamage;
			}

			if (adjAvgDamage > avgDamage)
			{
			   int rounds_left = this->estimate.rounds_left;
			   double durationRatio = data.duration < rounds_left ? (double)data.duration / rounds_left : 1.0;

			   if (Army->sMonInfo.attributes & CF_DONE)
			   {
				  durationRatio -= 1.0 / rounds_left;

				  if (durationRatio < 0.0)
					 durationRatio = 0.0;
			   }

			   totalCombatValue = targetArmy->get_total_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense);
			   value = (int)((sqrt(k) - 1.0) * totalCombatValue * durationRatio);
			}
		 }
		 
		 activeSpellMastery[targetArmy->group][targetArmy->index][SPELL_DEATH_BLOW] = savedSpellMastery;
	  }

	  delete targetArmy;
	  delete enemyArmy;
   }

#ifdef NEWSPELLS_DEBUG   
   showSpellInfo(SPELL_DEATH_BLOW, this, Army, Army->AI_target, data, totalCombatValue, value);
#endif

   return value;
}

// Drain Life
int type_AI_spellcaster::get_drain_life_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int valueParam = 0;

   if (!Army->spellInfluence[SPELL_DRAIN_LIFE] && !this->win_likely)
   {
	  value = Army->get_total_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense) / 2;
   }

   return value;
}

// Toughness
int type_AI_spellcaster::get_toughness_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int valueParam = 0;

   if (!Army->spellInfluence[SPELL_TOUGHNESS] && !this->win_likely)
   {
	  int healthBefore = Army->currentHealth();
	  float healthMul = Army->poison_penalty;
	  int toughnessHealthMod = o_Spell[SPELL_TOUGHNESS].effect[data.mastery];
	  double fullHealth = (double)Army->origHitPoints * healthMul * toughnessHealthMod / 100.0;

	  if (Army->spellInfluence[SPELL_AGE])
		 fullHealth *= ageSpell[Army->group][Army->index].healthMod / 100.0;
   
	  int health = (int)(fullHealth + 0.95);
	  int healthAfter = health * Army->numTroops - (health - 1 < Army->residualDamage ? health - 1 : Army->residualDamage);
	  value = (int)(o_pCreatureInfo[Army->armyType].fight_value * (double)(healthAfter - healthBefore) / Army->origHitPoints);
	  valueParam = healthAfter - healthBefore;
   }

#ifdef NEWSPELLS_DEBUG   
   showSpellInfo(SPELL_TOUGHNESS, this, Army, Army->AI_target, data, valueParam, value);
#endif

   return value;
}

// Behemoth's Claws
int type_AI_spellcaster::get_behemoths_claws_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int totalCombatValue = 0;
   
   if (!Army->spellInfluence[SPELL_BEHEMOTHS_CLAWS] && Army->AI_target && Army->AI_target->numTroops > 0 && !this->win_likely)
   {
	  army* targetArmy = new army;
	  targetArmy->copyConstructor(Army);

	  army* enemyArmy = new army;
	  enemyArmy->copyConstructor(Army->AI_target);

	  if (!targetArmy->can_shoot() && targetArmy->get_AI_target_time(targetArmy->GetSpeed()) == 1)
	  {
		 int savedSpellMastery = activeSpellMastery[targetArmy->group][targetArmy->index][SPELL_BEHEMOTHS_CLAWS];

		 ++targetArmy->numSpellInfluences;
		 targetArmy->spellInfluence[SPELL_BEHEMOTHS_CLAWS] = data.duration;
		 activeSpellMastery[targetArmy->group][targetArmy->index][SPELL_BEHEMOTHS_CLAWS] = data.mastery;

		 int targetArmyHealth = targetArmy->get_total_hit_points();
		 int enemyArmyHealth = enemyArmy->get_total_hit_points();
		 int avgDamageBeforeAttack = targetArmy->get_average_damage(enemyArmy, targetArmy->can_shoot(),
			(targetArmy->sMonInfo.hitPoints + targetArmyHealth - 1) / targetArmy->sMonInfo.hitPoints);

		 this->estimate.simulate_attack(targetArmy, targetArmyHealth, enemyArmy, enemyArmyHealth, targetArmy->can_shoot());

		 if (targetArmyHealth > 0)
		 {
			int avgDamageAfterAttack = targetArmy->get_average_damage(enemyArmy, targetArmy->can_shoot(),
			   (targetArmy->sMonInfo.hitPoints + targetArmyHealth - 1) / targetArmy->sMonInfo.hitPoints);

			if (targetArmy->can_shoot() && targetArmy->sMonInfo.attributes & CF_TWO_ATTACKS)
			   avgDamageAfterAttack /= 2;
            
			double k = 1.0 + (double)avgDamageAfterAttack / avgDamageBeforeAttack;

			int avgDamage = targetArmy->get_average_damage(enemyArmy, targetArmy->can_shoot(), targetArmy->numTroops);
			int adjAvgDamage = (int)(k * avgDamage);
			targetArmyHealth = targetArmy->get_total_hit_points();

			if (adjAvgDamage > targetArmyHealth)
			{
			   adjAvgDamage = targetArmyHealth;
			   k = (double)targetArmyHealth / avgDamage;
			}
            
			if (adjAvgDamage > avgDamage)
			{
			   int rounds_left = this->estimate.rounds_left;
			   double durationRatio =
				  data.duration < rounds_left ? (double)data.duration / rounds_left : 1.0;

			   if (Army->sMonInfo.attributes & CF_DONE)
			   {
				  durationRatio -= 1.0 / rounds_left;

				  if (durationRatio < 0.0)
					 durationRatio = 0.0;
			   }

			   totalCombatValue = targetArmy->get_total_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense);
			   value = (int)((sqrt(k) - 1.0) * totalCombatValue * durationRatio);
			}
		 }

		 activeSpellMastery[targetArmy->group][targetArmy->index][SPELL_BEHEMOTHS_CLAWS] = savedSpellMastery;
	  }
      
	  delete targetArmy;
	  delete enemyArmy;
   }

#ifdef NEWSPELLS_DEBUG   
   showSpellInfo(SPELL_BEHEMOTHS_CLAWS, this, Army, Army->AI_target, data, totalCombatValue, value);
#endif

   return value;
}

// Hour of Power
int type_AI_spellcaster::get_hour_of_power_value(army* const Army, type_enchant_data data) const
{
   int value = 0;
   int valueParam = 0;

   if (!Army->spellInfluence[SPELL_HOUR_OF_POWER] && !this->win_likely)
   {
	  value = Army->get_total_combat_value(this->estimate.lowest_attack, this->estimate.lowest_defense) / 2;
   }

   return value;
}

// Default
int type_AI_spellcaster::unimplemented(army* const Army, type_enchant_data data) const
{
   return 0;
}

int (type_AI_spellcaster::*type_AI_spellcaster::get_enchantment_function(SpellID spell) const)(army* const, type_enchant_data) const
{
   switch (spell)
   {
   case SPELL_ANTI_MAGIC:
	  return &type_AI_spellcaster::get_antimagic_value;
   case SPELL_POISON:
	  return &type_AI_spellcaster::get_poison_value;
   case SPELL_DISEASE:
      return &type_AI_spellcaster::get_disease_value;
   case SPELL_AGE:
      return &type_AI_spellcaster::get_age_value;
   case SPELL_FEAR:
      return &type_AI_spellcaster::get_fear_value;
   case SPELL_DEATH_BLOW:
      return &type_AI_spellcaster::get_death_blow_value;
   case SPELL_DRAIN_LIFE:
      return &type_AI_spellcaster::get_drain_life_value;
   case SPELL_TOUGHNESS:
	  return &type_AI_spellcaster::get_toughness_value;
   case SPELL_BEHEMOTHS_CLAWS:
	  return &type_AI_spellcaster::get_behemoths_claws_value;
   case SPELL_HOUR_OF_POWER:
	  return &type_AI_spellcaster::get_hour_of_power_value;
   default:
	  return &type_AI_spellcaster::unimplemented;
   }
}

int __stdcall get_enchantment_function(HiHook* h, type_AI_spellcaster* caster, SpellID spell)
{
   int (__thiscall type_AI_spellcaster::*value_func)(army* const, type_enchant_data) const = caster->get_enchantment_function(spell);

   switch (spell)
   {
   case SPELL_ANTI_MAGIC:
   case SPELL_POISON:
   case SPELL_DISEASE:
   case SPELL_AGE:
   case SPELL_FEAR:
   case SPELL_DEATH_BLOW:
   case SPELL_DRAIN_LIFE:
   case SPELL_TOUGHNESS:
   case SPELL_BEHEMOTHS_CLAWS:
   case SPELL_HOUR_OF_POWER:
	  return (int&)value_func;
   case SPELL_EXPLOSION:
   case SPELL_GOLDEN_TOUCH:
	  // get_damage_spell_value
	  return 0x436BB0;
   default:
	  return CALL_2(int, __thiscall, h->GetDefaultFunc(), caster, spell);
   }
}

int __stdcall consider_spell(LoHook* h, HookContext* c)
{
   enum SpellID spell = (SpellID)c->edi;
   int schoolLevel = *(int*)(c->ebx + 4);
   int spellPower = *(int*)(c->ebx + 8);
   type_AI_spellcaster* caster = (type_AI_spellcaster*)c->esi;
   type_spell_choice* spellChoice = (type_spell_choice*)c->ebx;
   
   switch (spell)
   {
   case SPELL_DEATH_CLOUD_NEW:
   case SPELL_INCINERATION:
	  c->return_address = 0x43B9D9;
	  return NO_EXEC_DEFAULT;

   case SPELL_SUMMON_FIRE_ELEMENTAL:
   case SPELL_SUMMON_EARTH_ELEMENTAL:
   case SPELL_SUMMON_WATER_ELEMENTAL:
   case SPELL_SUMMON_AIR_ELEMENTAL:
   case SPELL_SUMMON_SPRITE:
   case SPELL_SUMMON_MAGIC_ELEMENTAL:
   case SPELL_SUMMON_FIREBIRD:
	  if (!caster->win_likely && pCombatManager->AbleToSummonElemental(spell, caster->our_group))
      {
		 spellChoice->cast_now = true;
         
         int unitsNum = max((int)(getSummoningEffect(spell, schoolLevel) * spellPower), 1);

		 int k = caster->estimate.kills_only ? 1000 : o_pCreatureInfo[get_elemental_type(spell)].AI_value;
		 spellChoice->value = k * unitsNum;
      }
      break;
   default:
      return EXEC_DEFAULT;
   }
   
   c->return_address = 0x43B9BF;
   return NO_EXEC_DEFAULT;
}

int __stdcall getCancelValue(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ebx;

   if (Army)
   {
	  int spell = c->esi;
	  *(int*)(c->ebp - 0x28) = activeSpellMastery[Army->group][Army->index][spell];
   }

   return EXEC_DEFAULT;
}

int __stdcall AI_TreatFearEffect(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ebx;

   if (Army && Army->spellInfluence[SPELL_FEAR])
   {
	  c->return_address = 0x43A438;
	  return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall AI_TreatFearEffect2(LoHook* h, HookContext* c)
{
   army* Army = (army*)(c->eax - 0x2B0);

   //debugStrWin("%d %s", Army->numTroops, o_pCreatureInfo[Army->armyType].name_plural);

   if (Army && Army->spellInfluence[SPELL_FEAR])
   {
	  c->return_address = 0x43A50D;
	  return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall AI_TreatFearEffect3(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->ebx;

   if (Army && Army->spellInfluence[SPELL_FEAR])
   {
	  c->return_address = 0x43A67C;
	  return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}
// ===============================================================

// ===============================================================
// ---------------------------- Fear -----------------------------
// ---------------------------------------------------------------
int __stdcall skipMeleeAttackUnderFear(LoHook* h, HookContext* c)
{
   army* Army = pCombatManager->GetActiveStack();
   
   if (Army && Army->spellInfluence[SPELL_FEAR])
   {
      c->return_address = 0x4220B3;
      return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall skipShootingUnderFear(LoHook* h, HookContext* c)
{
   army* Army = pCombatManager->GetActiveStack();
   
   if (Army && Army->spellInfluence[SPELL_FEAR])
   {
      c->return_address = 0x41F263;
      return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall setCursorForFearSpell(HiHook* h, CombatManager* combatMgr, int hex)
{
   int cursorType = CALL_2(int, __thiscall, h->GetDefaultFunc(), combatMgr, hex);

   army* Army = combatMgr->GetActiveStack();
      
   if (Army && Army->spellInfluence[SPELL_FEAR] && (cursorType == 3 || cursorType == 15 || cursorType == 7))
      return 0;

   return cursorType;
}
// ===============================================================

// Death Cloud, Explosion, Incineration, Golden Touch
int __stdcall castBattleSpell(LoHook* h, HookContext* c)
{
   int targetCell = *(int*)(c->ebp + 0xC);
   int iSpellType = c->edx;
   TSkillMastery mastery = (TSkillMastery)c->esi;
   int power = *(int*)(c->ebp + 0x1C);
   army* Army = (army*)c->edi;
   
   switch (iSpellType)
   {
   case SPELL_DEATH_CLOUD_NEW:
   case SPELL_INCINERATION:
	  pCombatManager->AreaEffect(targetCell, iSpellType, mastery, power);
	  break;
   case SPELL_EXPLOSION:
	  if (explosionSpeedReduction && !(Army->sMonInfo.attributes & CF_SIEGE_WEAPON))
	  {
		 explosionSpell[Army->group][Army->index].speedPenalty = max(1, Army->sMonInfo.speed - 1) < Army->sMonInfo.speed;
		 Army->sMonInfo.speed = max(1, Army->sMonInfo.speed - 1);
	  }
	  c->return_address = 0x5A0E2A;
	  return NO_EXEC_DEFAULT;
   case SPELL_GOLDEN_TOUCH:
	  if (mastery < eMasteryExpert)
	  {
		 c->return_address = 0x5A0E2A;
		 return NO_EXEC_DEFAULT;
	  }
	  else
		 pCombatManager->AreaEffect(targetCell, iSpellType, mastery, power);
	  break;
   default:
	  return EXEC_DEFAULT;
   }

   c->return_address = 0x5A2368;
   return NO_EXEC_DEFAULT;
}

int __stdcall spellTableAHelper(LoHook* h, HookContext* c)
{
   int iSpellType = c->ebx;
   TSkillMastery mastery = *(TSkillMastery*)(c->ebp + 8);
   
   switch (iSpellType)
   {
   case SPELL_GOLDEN_TOUCH:
	  o_Spell[SPELL_GOLDEN_TOUCH].type = 0;
	  if (mastery < eMasteryExpert)
	  {
		 o_Spell[SPELL_GOLDEN_TOUCH].flags = SF_BATTLE_SPELL|SF_SINGLE_TARGET|SF_DAMAGE_SPELL|SF_NOT_AT_WAR_MACHINE|SF_AI_DAMAGE_SPELL; //37393;
		 c->edx = 4;
	  }
	  else
	  {
		 o_Spell[SPELL_GOLDEN_TOUCH].flags = SF_BATTLE_SPELL|SF_TARGET_ANYWHERE|SF_DAMAGE_SPELL|SF_NOT_AT_WAR_MACHINE|SF_AI_DAMAGE_SPELL; //37505;
		 c->edx = 5;
	  }
	  break;
   }

   return EXEC_DEFAULT;
}

int __stdcall spellTableFHelper(LoHook* h, HookContext* c)
{
   int iSpellType = c->edi;
   type_spell_choice* spell_choice = *(type_spell_choice**)(c->ebp + 8);
   TSkillMastery mastery = spell_choice->mastery;
   
   switch (iSpellType)
   {
   case SPELL_GOLDEN_TOUCH:
	  if (mastery < eMasteryExpert)
	  {
		 o_Spell[SPELL_GOLDEN_TOUCH].type = -1;
		 o_Spell[SPELL_GOLDEN_TOUCH].flags = SF_BATTLE_SPELL|SF_SINGLE_TARGET|SF_DAMAGE_SPELL|SF_NOT_AT_WAR_MACHINE|SF_AI_DAMAGE_SPELL; //37393;
		 c->ecx = 9;
	  }
	  else
	  {
		 o_Spell[SPELL_GOLDEN_TOUCH].type = 0;
		 o_Spell[SPELL_GOLDEN_TOUCH].flags = SF_BATTLE_SPELL|SF_TARGET_ANYWHERE|SF_DAMAGE_SPELL|SF_NOT_AT_WAR_MACHINE|SF_AI_DAMAGE_SPELL; //37505;
		 c->ecx = 2;
	  }
	  break;
   }

   return EXEC_DEFAULT;
}

int __stdcall showAreaAnim(LoHook* h, HookContext* c)
{
   SpellID spell = *(SpellID*)(c->ebp + 0xC);

   if (spell == SPELL_GOLDEN_TOUCH)
   {
	  *(int*)(c->ebp - 0x18) = c->ebx;
	  *(int*)(c->ebp - 0x14) = c->eax << 3;

	  c->return_address = 0x5A4CCD;
	  return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall goldenTouchAreaAnim(LoHook* h, HookContext* c)
{
   SpellID spell = *(SpellID*)(c->ebp + 0xC);

   if (spell == SPELL_GOLDEN_TOUCH)
   {
	  for (int side = ATTACKER; side <= DEFENDER; ++side)
	  {
		 for (int i = 0; i < 20; ++i)
		 {
			army* Army = (army*)&pCombatManager->stack[side][i];
			
			if (Army && massSpellTarget[side][i])
			{
			   float workChance = pCombatManager->SpellCastWorkChance(SPELL_GOLDEN_TOUCH, pCombatManager->current_side, Army);

			   //debugStr("%s: %d (%f)", Army->sMonInfo.name_plural, Army->count_current, workChance);
			   
			   if (!workChance)
				  massSpellTarget[side][i] = false;
			}
		 }
	  }
	  
	  pCombatManager->ShowMassSpell(massSpellTarget, o_Spell[SPELL_GOLDEN_TOUCH].animation_ix, false);
   }

   return EXEC_DEFAULT;
}

int getGoldenTouchEffect(hero* const Hero, army* const Army, const int killed_creatures)
{
   double goldenTouchEffect[] = {0.10, 0.10, 0.15, 0.20};
   TSkillMastery mastery = (TSkillMastery)Hero->SSLevel[Hero->getBestMagicSchoolForSpell(SPELL_GOLDEN_TOUCH)];

   return max(1, (int)(killed_creatures * Army->sMonInfo.cost[GOLD] * goldenTouchEffect[mastery]));
}

int __stdcall goldenTouchAddGoldSingleTarget(LoHook* h, HookContext* c)
{
   SpellID spell = *(SpellID*)(c->ebp + 8);
   hero* Hero = (hero*)pCombatManager->hero[pCombatManager->current_side];
   
   if (Hero && spell == SPELL_GOLDEN_TOUCH)
   {
	  army* Army = (army*)c->edi;
	  int killed_creatures = c->eax;
	  
	  if (killed_creatures)
	  {
		 int goldTransmuted = getGoldenTouchEffect(Hero, Army, killed_creatures);
		 goldenTouchSpell[pCombatManager->current_side].goldForCast = goldTransmuted;
		 goldenTouchSpell[pCombatManager->current_side].goldForBattle += goldTransmuted;
		 o_GameMgr->GetPlayer(Hero->playerOwner)->resourses.gold += goldTransmuted;
	  }
   }

   return EXEC_DEFAULT;
}

int __stdcall goldenTouchAddGold(LoHook* h, HookContext* c)
{
   SpellID spell = *(SpellID*)(c->ebp + 0xC);
   hero* Hero = (hero*)pCombatManager->hero[pCombatManager->current_side];
   
   if (Hero && spell == SPELL_GOLDEN_TOUCH)
   {
	  army* Army = (army*)c->edi;
	  int killed_creatures = c->eax;
	  
	  if (killed_creatures)
	  {
		 int goldTransmuted = getGoldenTouchEffect(Hero, Army, killed_creatures);
		 goldenTouchSpell[pCombatManager->current_side].goldForCast += goldTransmuted;
		 goldenTouchSpell[pCombatManager->current_side].goldForBattle += goldTransmuted;
		 o_GameMgr->GetPlayer(Hero->playerOwner)->resourses.gold += goldTransmuted;
	  }
   }

   return EXEC_DEFAULT;
}

char goldenTouchTxtBuffer[1024];
int __stdcall appendCombatLogInfo(LoHook* h, HookContext* c)
{
   if (goldenTouchSpell[pCombatManager->current_side].goldForCast)
   {
	  char* msg = (char*)c->eax;
	  
	  sprintf(goldenTouchTxtBuffer, "%s %d %s", msg, goldenTouchSpell[pCombatManager->current_side].goldForCast, goldenTouchCombatLogMessage);
	  goldenTouchSpell[pCombatManager->current_side].goldForCast = 0;
	  c->eax = (int)goldenTouchTxtBuffer;
   }

   return EXEC_DEFAULT;
}

int __stdcall notifyPlayerAfterBattle(LoHook* h, HookContext* c)
{
   for (int i = ATTACKER; i <= DEFENDER; ++i)
   {
	  if (o_GameMgr->GetMe()->IsHuman() && goldenTouchSpell[i].goldForBattle && pCombatManager->hero[i] && pCombatManager->hero[i]->owner_id == o_GameMgr->GetMeID())
		 CALL_12(void, __fastcall, 0x4F6C00, goldenTouchWinBattleMessage, MBX_OK, -1, -1, 6, goldenTouchSpell[i].goldForBattle, -1, 0, -1, 0, -1, 0);
   }

   return EXEC_DEFAULT;
}

int __stdcall applyIncinerationSpecialFeature(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->edi;
   int damage = c->eax;

   *(int*)(c->ebp - 0x24) = damage;
   int numDestroyed = Army->Damage(damage);
   c->eax = numDestroyed;
   
   if (incinerationSpecialFeature)
   {
	  int spell = c->esi;
	  if (spell == SPELL_INCINERATION)
	  {
		 Army->origNumTroops -= numDestroyed;
		 if (Army->numTroops <= 0)
			Army->sMonInfo.attributes |= CF_SACRIFICED;
	  }
   }

   c->return_address = 0x5A4DF2;
   return NO_EXEC_DEFAULT;
}

/*int army::get_resurrection_size(army* const target) const
{
   int origNum = incinerationSpecialFeature ? origNumTroops[target->group][target->index] : target->origNumTroops;
   
   int destroyedNumTroops = origNum - target->numTroops;
   int unitsToResurrect;

   if (this->armyType == eCreatureArchangel)
	  unitsToResurrect = 100 * this->numTroops / target->sMonInfo.hitPoints;
   else
   {
	  int hitPointsToResurrect = min(50 * this->numTroops, destroyedNumTroops * target->sMonInfo.hitPoints);
	  unitsToResurrect = hitPointsToResurrect / o_pCreatureInfo[eCreatureDemon].hit_points;
   }

   return min(destroyedNumTroops, unitsToResurrect);
}

int __fastcall get_resurection_size(army* const Army, int unused_edx, army* const target)
{
   return Army->get_resurrection_size(target);
}*/

int __stdcall get_area_effect_new(LoHook* h, HookContext* c)
{
   int spell = c->edi;

   switch (spell)
   {
   case SPELL_FROST_RING:
   case SPELL_FIREBALL:
   case SPELL_INFERNO:
   case SPELL_METEOR_SHOWER:
   case SPELL_DEATH_CLOUD_NEW:
   case SPELL_INCINERATION:
   case SPELL_GOLDEN_TOUCH:
	  c->return_address = 0x41FC03;
	  return NO_EXEC_DEFAULT;
   default:
	  return EXEC_DEFAULT;
   }
}

// Death Blow
int __stdcall DeathBlow(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;
   int schoolLevel = activeSpellMastery[Army->group][Army->index][SPELL_DEATH_BLOW];
   
   if (Army->spellInfluence[SPELL_DEATH_BLOW] && pCombatManager->GetAction() == 6 &&
	  Randint(1, 100) <= o_Spell[SPELL_DEATH_BLOW].effect[schoolLevel])
   {
	  bool virtualDamage = *(bool*)&c->ebx;
      c->return_address = virtualDamage ? 0x44388E : 0x4436E7;
      return NO_EXEC_DEFAULT;
   }
   
   return EXEC_DEFAULT;
}

// Drain Life
int __stdcall DrainLife(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;
   
   if (Army->spellInfluence[SPELL_DRAIN_LIFE])
   {
      c->return_address = 0x440921;
      return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall calcDrainLifeHeal(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;

   if (Army->spellInfluence[SPELL_DRAIN_LIFE])
      c->edx = (int)(c->edx * o_Spell[SPELL_DRAIN_LIFE].effect[activeSpellMastery[Army->group][Army->index][SPELL_DRAIN_LIFE]] / 100.0);

   return EXEC_DEFAULT;
}

// ===============================================================
// --------------------- Adventure Spells ------------------------
// ---------------------------------------------------------------
bool eyeOfTheMagiCast = false;

int __stdcall eyeOfTheMagi(LoHook* h, HookContext* c)
{
   if (eyeOfTheMagiCast)
   {
	  c->return_address = 0x4915C0;
	  return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

void __stdcall setMouseCursor(HiHook* h, MouseManager* mouseManager, int new_frame, MouseManager::EPointerSet new_set)
{
   if (eyeOfTheMagiCast && new_frame == 41 && new_set == MouseManager::ADVENTURE_SET)
   {
	  new_frame = 0;
	  new_set = MouseManager::SPELL_SET;
   }

   CALL_3(void, __thiscall, h->GetDefaultFunc(), mouseManager, new_frame, new_set);
}

int mobilitySpellParams[] = {1, 2, 3, 4};
int eyeOfTheMagiSpellParams[] = {1, 2, 3, 4};

int __stdcall castAdventureSpell(LoHook* h, HookContext* c)
{
   SpellID spell = *(SpellID*)(c->ebp + 8);
   hero* Hero = (hero*)c->esi;

   int special_terrain = Hero->get_special_terrain();
   int schoolLevel = Hero->get_spell_level(spell, special_terrain);

   switch (spell)
   {
   case SPELL_MOBILITY:
	  if (heroAdvInfoEx[Hero->id].mobilityCastCount < mobilitySpellParams[schoolLevel])
	  {
		 if (mobilityRequiresBattle && !heroAdvInfoEx[Hero->id].mobilityWonBattle)
		 {
			sprintf(o_TextBuffer, mobilityWinBattleMessage, Hero->name);
			b_MsgBox(o_TextBuffer, MBX_OK);
		 }
		 else
		 {
			++heroAdvInfoEx[Hero->id].mobilityCastCount;
			heroAdvInfoEx[Hero->id].mobilityWonBattle = false;
			Hero->UseSpell(Hero->GetManaCost(SPELL_MOBILITY, NULL, special_terrain));
			Hero->currMobility += o_Spell[SPELL_MOBILITY].effect[schoolLevel];
			Hero->maxMobility += o_Spell[SPELL_MOBILITY].effect[schoolLevel];
			pAdventureManager->ShowRoute(0, 0, 1);
			pAdventureManager->FullUpdate(true);
			playSound(o_Spell[SPELL_MOBILITY].wav_name);
		 }
	  }
	  else
	  {
		 sprintf(o_TextBuffer, o_GENRLTXT_TXT->GetString(339), Hero->name);
		 b_MsgBox(o_TextBuffer, MBX_OK);
	  }
	  break;

   case SPELL_EYE_OF_THE_MAGI:
	  if (heroAdvInfoEx[Hero->id].eyeOfTheMagiCastCount < eyeOfTheMagiSpellParams[schoolLevel])
	  {
		 HeroWindow* heroWindow = new HeroWindow();
		 CALL_1(void, __thiscall, 0x41D326 + 5 + *(int*)0x41D327, heroWindow);
		 eyeOfTheMagiCast = true;
		 heroWindow->DoModal(false);
		 eyeOfTheMagiCast = false;
		 CALL_1(void, __thiscall, 0x41D346 + 5 + *(int*)0x41D347, heroWindow);

		 type_point mapPoint;
		 pAdventureManager->get_mouse_map_point(mapPoint);

		 if (mapPoint.is_valid() && pWindowManager->Field<int>(0x38))
		 {
			int x, y;
			pGame->SetVisibility(mapPoint.x, mapPoint.y, mapPoint.z, o_ActivePlayer->id, o_Spell[SPELL_EYE_OF_THE_MAGI].effect[schoolLevel], 0);
			pAdventureManager->Field<int>(0xEC) = -1;
			pMouseManager->MouseCoords(x, y);
			pAdventureManager->ProcessHover(x, y);
		 }
		 else
		 {
			sprintf(o_TextBuffer, o_GENRLTXT_TXT->GetString(732));
			b_MsgBox(o_TextBuffer, MBX_OK);
			break;
		 }

		 ++heroAdvInfoEx[Hero->id].eyeOfTheMagiCastCount;
		 Hero->UseSpell(Hero->GetManaCost(SPELL_EYE_OF_THE_MAGI, NULL, special_terrain));
		 pAdventureManager->FullUpdate(true);
		 playSound(o_Spell[SPELL_EYE_OF_THE_MAGI].wav_name);
	  }
	  else
	  {
		 sprintf(o_TextBuffer, o_GENRLTXT_TXT->GetString(339), Hero->name);
		 b_MsgBox(o_TextBuffer, MBX_OK);
	  }
	  break;
   
   default:
	  return EXEC_DEFAULT;
   }
   
   c->return_address = 0x41C67B;
   return NO_EXEC_DEFAULT;
}

void loadFromGameFile(const int addr, void* buffer, const int size)
{
   CALL_3(void, __thiscall, *(int*)(*(int*)addr + 4), addr, buffer, size);
}

void saveToGameFile(const int addr, void* buffer, const int size)
{
   CALL_3(void, __thiscall, *(int*)(*(int*)addr + 8), addr, buffer, size);
}

int __stdcall loadHeroAdvInfoEx(LoHook* h, HookContext* c)
{
   hero* Hero = (hero*)c->edi;

   if (Hero)
   {
	  loadFromGameFile(c->esi, &heroAdvInfoEx[Hero->id].mobilityCastCount, sizeof(heroAdvInfoEx[Hero->id].mobilityCastCount));
	  loadFromGameFile(c->esi, &heroAdvInfoEx[Hero->id].mobilityWonBattle, sizeof(heroAdvInfoEx[Hero->id].mobilityWonBattle));
	  loadFromGameFile(c->esi, &heroAdvInfoEx[Hero->id].eyeOfTheMagiCastCount, sizeof(heroAdvInfoEx[Hero->id].eyeOfTheMagiCastCount));
   }

   return EXEC_DEFAULT;
}

int __stdcall saveHeroAdvInfoEx(LoHook* h, HookContext* c)
{
   hero* Hero = (hero*)c->edi;
   
   if (Hero)
   {
	  saveToGameFile(c->esi, &heroAdvInfoEx[Hero->id].mobilityCastCount, sizeof(heroAdvInfoEx[Hero->id].mobilityCastCount));
	  saveToGameFile(c->esi, &heroAdvInfoEx[Hero->id].mobilityWonBattle, sizeof(heroAdvInfoEx[Hero->id].mobilityWonBattle));
	  saveToGameFile(c->esi, &heroAdvInfoEx[Hero->id].eyeOfTheMagiCastCount, sizeof(heroAdvInfoEx[Hero->id].eyeOfTheMagiCastCount));
   }

   return EXEC_DEFAULT;
}
// ===============================================================

void hero::UpdateSpellsFromArtifacts()
{
   for (int iSpell = 0; iSpell < SPELLS_MAX; ++iSpell)
	  if (this->in_spellbook[iSpell] > SPELL_MEMORIZED)
		 this->in_spellbook[iSpell] = 0;

   for (int iSlot = 0; iSlot < 19; ++iSlot)
   {
	  if (this->equipped[iSlot].type != ID_NONE)
      {
         if (this->equipped[iSlot].type == eArtifactSpellScroll)
         {
			if (this->equipped[iSlot].spell < SPELLS_NUM && !this->in_spellbook[this->equipped[iSlot].spell])
			   this->in_spellbook[this->equipped[iSlot].spell] = SPELL_TEMPORARY;
         }
         else if (o_ArtInfo[this->equipped[iSlot].type].new_spell != ID_NONE)
         {
            _SpellBitset_ spells;
            CALL_2(int, __fastcall, 0x4D95C0, &spells, this->equipped[iSlot].type);

            for (std::size_t iSpell = 0; iSpell < spells.size(); ++iSpell)
            {
			   if (spells[iSpell] && !this->in_spellbook[iSpell])
                  this->in_spellbook[iSpell] = SPELL_TEMPORARY;
            }

            int comboArtIndex = o_ArtInfo[this->equipped[iSlot].type].supercomposite;
			
			if (comboArtIndex != -1)
            {
               for (int iArt = 0; iArt < ARTIFACTS_NUM; ++iArt)
               {
                  if (o_ComboArtInfo[comboArtIndex].parts[iArt] && o_ArtInfo[iArt].new_spell)
                  {
                     _SpellBitset_ spells;
                     CALL_2(int, __fastcall, 0x4D95C0, &spells, iArt);

                     for (std::size_t iSpell = 0; iSpell < spells.size(); ++iSpell)
                     {
                        if (spells[iSpell] && !this->in_spellbook[iSpell])
                           this->in_spellbook[iSpell] = SPELL_TEMPORARY;
                     }
                  }
               }
            }
         }
      }
   }
}

void __fastcall UpdateSpellsFromArtifacts(hero* Hero)
{
   Hero->UpdateSpellsFromArtifacts();   
}

int army::GetSpeed()
{
   int speed = this->sMonInfo.speed;

   if (this->spellInfluence[SPELL_SLOW] || this->spellInfluence[SPELL_DISEASE] || this->spellInfluence[SPELL_FEAR])
	  speed = this->sMonInfo.attributes & CF_SIEGE_WEAPON ? 0 : max((int)(speed * this->slowPenalty), 1);

   return speed;
}

int __fastcall GetSpeed(army* Army)
{
   return Army->GetSpeed();   
}

int __stdcall setSpellInfluence(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->esi;	 
   int spell = c->ebx;
   int spellDuration = c->eax;
   int spellMastery = *(int*)(c->ebp + 0x10);

   if (Army->spellInfluence[spell])
   {
	  if (spellDuration > Army->spellInfluence[spell])
		 Army->spellInfluence[spell] = spellDuration;
	  if (spellMastery > activeSpellMastery[Army->group][Army->index][spell])
		 activeSpellMastery[Army->group][Army->index][spell] = spellMastery;
	  c->return_address = 0x4450C2;
   }
   else
   {
	  ++Army->numSpellInfluences;
	  Army->spellInfluence[spell] = spellDuration;
	  activeSpellMastery[Army->group][Army->index][spell] = spellMastery;
	  c->Push(c->edi);
	  c->edi = o_Spell[spell].effect[spellMastery];
	  c->eax = spellMastery;
	  c->return_address = 0x4446E5;
   }

   return NO_EXEC_DEFAULT;
}

int __stdcall mobilitySetWin(LoHook* h, HookContext* c)
{
   hero* attHero = *(hero**)(c->ebp + 0xC);
   hero* defHero = (hero*)c->ebx;
   hero* winHero = 0;
   int winnerSide = c->eax;

   if (attHero && winnerSide == ATTACKER)
	  winHero = attHero;
   else if (defHero && winnerSide == DEFENDER)
	  winHero = defHero;

   if (winHero)
	  heroAdvInfoEx[winHero->id].mobilityWonBattle = true;
  
   return EXEC_DEFAULT;
}

int __stdcall cumulativeUnicornAura(LoHook* h, HookContext* c)
{
   army* Army = (army*)c->edi;
   int unicornAuraNum = Army->aura_sources.size();

   if (unicornAuraNum)
   {
	  SpellID spell = *(SpellID*)(c->ebp + 8);
	  TCreatureType target_army_type = *(TCreatureType*)(c->ebp - 0xC);
	  hero* attHero = *(hero**)(c->ebp + 0x10);
	  hero* defHero = *(hero**)(c->ebp - 4);
	  float chance = get_spell_work_chance(spell, target_army_type, defHero, attHero) * pow(0.8f, unicornAuraNum);

	  __asm { fld chance }

	  c->return_address = 0x5A88D9;
	  return EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall loadLod(LoHook* h, HookContext* c)
{
   int lodNumber = **(int**)(c->ebp - 0x18);
   if (lodNumber == 5)
   {
	  c->eax = (int)lodPath;
	  c->return_address = 0x55A592;
	  return NO_EXEC_DEFAULT;
   }

   return EXEC_DEFAULT;
}

int __stdcall loadSnd(LoHook* h, HookContext* c)
{
   c->eax = (int)sndPath;

   return EXEC_DEFAULT;
}

// Debug AI
#ifdef NEWSPELLS_DEBUG
void writeInfo(const char* headerStr, const int side, const type_AI_enemy_data* info)
{
   char buffer[2048];
   char infoStr[2048];
   sprintf(infoStr, "{%s}\n\n", headerStr);

   for (int i = 0; i < pCombatManager->stacks_count[side]; ++i)
   {
	  army* Army = (army*)&pCombatManager->stack[side][i];

	  sprintf(buffer, "{%d} %s\n{%d} %s\n{%d} | {%d} | {%d}\n\n",
		 Army->numTroops,
		 Army->numTroops > 1 ? Army->sMonInfo.m_plural_name : Army->sMonInfo.m_name,
		 info[i].enemy ? info[i].enemy->numTroops : -1,
		 info[i].enemy ? (info[i].enemy->numTroops > 1 ? o_pCreatureInfo[info[i].enemy->armyType].name_plural : o_pCreatureInfo[info[i].enemy->armyType].name_single) : "(none)",
		 info[i].count,
		 info[i].damage,
		 info[i].total_damage);
	  
	  strcat(infoStr, buffer);
   }

   debugStr("%s", infoStr);
}

void __stdcall AIShowInfo(HiHook* h, type_AI_spellcaster *spellcaster, CombatManager *combatMgr, int side, bool is_creature_spell)
{
   CALL_4(void, __thiscall, h->GetDefaultFunc(), spellcaster, combatMgr, side, is_creature_spell);

   writeInfo("Melee", side, &spellcaster->melee_enemies[0]);
   writeInfo("Shooting", side, &spellcaster->ranged_enemies[0]);
   writeInfo("Most powerful", side, &spellcaster->worst_enemies[0]);
}
#endif

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
   static bool plugin_On = false;
   if ( DLL_PROCESS_ATTACH == ul_reason_for_call )
   {
      if ( !plugin_On )
      {
         plugin_On = true;
         _P = GetPatcher();
         _PI = _P->CreateInstance("HD.Plugin.H3.NewSpells");

         char curDir[MAX_PATH];
		 GetCurrentDirectoryA(sizeof(curDir), curDir);
		 sprintf(iniPath, "%s\\NewSpells.ini", curDir);
		 
		 char lngName[32];
		 GetPrivateProfileStringA("Language", "<Name>", "English", lngName, sizeof(lngName), iniPath);

		 sprintf(lngPath, "%s\\Language\\%s.ini", curDir, lngName);
		 sprintf(lodPath, "%s\\NewSpells.lod", curDir);
		 sprintf(sndPath, "%s\\NewSpells.snd", curDir);

         // Moving and Expanding Spell Table
         _PI->WriteLoHook     (0x4EE1C1, afterInit);
               
         // nwcthereisnospoon
         _PI->WriteByte       (0x402902, SPELLS_NUM);

         // "(Already learned)" Text
         _PI->WriteDword      (0x40D97C, 0x3EA);
         
         // ===============================================================
         // ------------------------- Battle AI ---------------------------
         // ---------------------------------------------------------------
         _PI->WriteDword      (0x41FBDF, 0x3EA);
         _PI->WriteByte       (0x41FC91, SPELLS_NUM); // CombatManager::get_area_effect()
         _PI->WriteDword      (0x425C72, 0x3EA);
         _PI->WriteDword      (0x425E98, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x427039, 0x3EA);
         _PI->WriteDword      (0x427044, 0x3EA);
         _PI->WriteByte       (0x427085, SPELLS_NUM);
         _PI->WriteDword      (0x4329C1, 0x3EA);
         _PI->WriteDword      (0x432A43, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x432CDE, 0x3EA);
         _PI->WriteDword      (0x432D1E, SPELLS_NUM * sizeof(_Spell_));
		 // ---------------------------------------------------------------
         
         // ===============================================================
         // ----------------------- Adventure AI --------------------------
         // ---------------------------------------------------------------
         _PI->WriteDword      (0x430AE5, 0x3EA + SPELL_DIMENSION_DOOR);
         _PI->WriteDword      (0x4E57CC, 0x3EA + SPELL_SUMMON_BOAT);
         _PI->WriteDword      (0x56B346, 0x3EA + SPELL_TOWN_PORTAL);
         _PI->WriteDword      (0x56B7EA, 0x3EA + SPELL_DIMENSION_DOOR);
         _PI->WriteDword      (0x56B93F, 0x3EA + SPELL_FLY);
         _PI->WriteDword      (0x56B99A, 0x3EA + SPELL_WATER_WALK);
		 // AI Value of Pyramid
         _PI->WriteDword      (0x52A97A, 0x3EA);
         _PI->WriteDword      (0x52A9B6, SPELLS_NUM * sizeof(_Spell_));
         // ===============================================================
         
         // ===============================================================
         // ------------------------ Battle AI ----------------------------
         // ---------------------------------------------------------------
         _PI->WriteDword      (0x4397E6, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x43C6F2, SPELLS_NUM * sizeof(_Spell_));
		 _PI->WriteLoHook	  (0x43975F, getCancelValue);
         // Master Genie AI Spell Weighting
         _PI->WriteDword      (0x43C21B, SPELLS_NUM * sizeof(_Spell_));
         // AI Quick Battle
         _PI->WriteDword      (0x433026, 0x3EA);
         _PI->WriteDword      (0x433719, 0x3EA);
         _PI->WriteDword      (0x43940C, 0x3EA);
         _PI->WriteDword      (0x43C561, 0x3EA);
		 // Treat Fear effect like that of Blind/Stone Gaze/Paralyze
		 _PI->WriteLoHook	  (0x43A371, AI_TreatFearEffect);
		 _PI->WriteLoHook	  (0x43A4FD, AI_TreatFearEffect2);
		 _PI->WriteLoHook	  (0x43A603, AI_TreatFearEffect3);
		 // ===============================================================
                           
         // Can cast
         _PI->WriteDword      (0x447551, SPELLS_NUM * sizeof(_Spell_));
         
         _PI->WriteDword      (0x447C7D, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x447CC8, SPELLS_NUM * sizeof(_Spell_));
         
         // Cheats in battle
         _PI->WriteByte       (0x471C57, SPELLS_NUM);
         
         // Clear Hero.spell[140] (optional)
         _PI->WriteDword      (0x48647A, 0x23);
         _PI->WriteJmp        (0x486485, 0x486498);
         
         _PI->WriteByte       (0x4864B0, SPELLS_NUM);
                  
         // Scholar Secondary Skill
         _PI->WriteByte       (0x4A2743, SPELLS_NUM);

		 // Load Game
         _PI->WriteByte       (0x48A34B, SPELLS_NUM);

         _PI->WriteByte       (0x4E67AC, SPELLS_NUM);
         
         // Cheat Menu?
         _PI->WriteByte       (0x4F508B, SPELLS_NUM);
         _PI->WriteDword      (0x4F50CE, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x4F5114, SPELLS_NUM * sizeof(_Spell_));
                           
         // Init spells
		 _PI->WriteLoHook     (0x4C2625, initSpells);
         
		 // Shrine spells
         _PI->WriteDword      (0x4C92C5, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x4C9347, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x4C93C0, SPELLS_NUM * sizeof(_Spell_));
		 _PI->WriteHiHook     (0x4C9260, SPLICE_, DIRECT_, THISCALL_, FillShrine);

		 // Pyramids
         _PI->WriteByte       (0x4C170D, SPELLS_NUM);
                 
         _PI->WriteByte       (0x4CEC4F, SPELLS_NUM);
         
         // Clear Hero.spell[140] (optional)
         _PI->WriteDword      (0x4D8F2E, 0x23);
         _PI->WriteJmp        (0x4D8F36, 0x4D8F49);
         
         // Tome of Air Magic
         _PI->WriteDword      (0x4D962D, SPELLS_NUM * sizeof(_Spell_));
         // Tome of Fire Magic
         _PI->WriteDword      (0x4D9681, SPELLS_NUM * sizeof(_Spell_));
         // Tome of Water Magic
         _PI->WriteDword      (0x4D96D6, SPELLS_NUM * sizeof(_Spell_));
         // Tome of Earth Magic
         _PI->WriteDword      (0x4D972E, SPELLS_NUM * sizeof(_Spell_));
         // Spellbinder's Hat
         _PI->WriteDword      (0x4D9771, SPELLS_NUM * sizeof(_Spell_));
         
         // Scholars
         _PI->WriteByte       (0x5012B7, SPELLS_NUM);
         
         _PI->WriteDword      (0x527ACB, 0x3EA);
         _PI->WriteDword      (0x527B08, SPELLS_NUM * sizeof(_Spell_));
		 
		 // RMG
		 _PI->WriteDword      (0x534C4B, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteLoHook     (0x54AE0F, RMGDisableSpells);
         
         // RMG Spell Scrolls
         _PI->WriteDword      (0x5353D5, SPELLS_NUM);
         _PI->WriteByte       (0x53542B, SPELLS_NUM);
         _PI->WriteLoHook     (0x5353E8, RMGDisableSpellsInScrollsA);
         _PI->WriteLoHook     (0x535417, RMGDisableSpellsInScrollsB);
         
         // Spell Book
         _PI->WriteDword      (0x59CCDD, SPELLS_NUM * sizeof(_BookSpell_));
		 _PI->WriteDword      (0x59CD36, SPELLS_NUM * sizeof(_BookSpell_));
		 _PI->WriteDword      (0x59CD5E, 0x3EA);
         _PI->WriteDword      (0x59CDBF, SPELLS_NUM * sizeof(_Spell_));

		 // Add Spell
		 _PI->WriteHiHook     (0x4D95A0, SPLICE_, DIRECT_, THISCALL_, AddSpell);
		 
         // Cast Spell
         _PI->WriteDword      (0x5A1AD6, SPELLS_NUM * sizeof(_Spell_));

		 // Anti-Magic
		 _PI->WriteDword      (0x4447FE, SPELLS_NUM * sizeof(_Spell_));

		 // ===============================================================
         // -------------------------- Mage Guild -------------------------
         // ---------------------------------------------------------------
		 _PI->WriteByte       (0x5BEA2C, SPELLS_NUM);
         _PI->WriteByte       (0x5BEA70, SPELLS_NUM);
         _PI->WriteByte       (0x5BEAAD, SPELLS_NUM);
         _PI->WriteDword      (0x5BEAFE, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x5BEB2C, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteByte       (0x5BEB48, SPELLS_NUM);
         _PI->WriteByte       (0x5BEB71, SPELLS_NUM);
         _PI->WriteByte       (0x5BEBB2, SPELLS_NUM);
         _PI->WriteDword      (0x5BEC05, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteByte       (0x5BEC1B, SPELLS_NUM);
		 
		 // Town setup
		 _PI->WriteByte       (0x5BEA05, 0x30); // Now we have the equivalent of std::bitset<SPELLS_MAX> on the stack
		 _PI->WriteDword      (0x5BEA12, 4); // Let's initialize it with zeroes
		 
		 int newBitsetOffset[] = {0x5BEA67, 0x5BEAB2, 0x5BEACF, 0x5BEB50, 0x5BEB68, 0x5BEBB7, 0x5BEBD6, 0x5BEC23, 0x5BEC3B};
		 for (std::size_t i = 0; i < sizeof(newBitsetOffset) / sizeof(int); ++i)
            _PI->WriteByte(newBitsetOffset[i], -0x30);

		 _PI->WriteLoHook	  (0x5BEA24, expandMayAppearSpells);
		 _PI->WriteLoHook	  (0x5BE518, expandMayAppearSpells); // Aurora Borealis
		 _PI->WriteLoHook	  (0x5BE52D, expandMayAppearSpells); // Aurora Borealis
		 _PI->WriteLoHook	  (0x5BEB15, expandMustAppearSpells);
         // ===============================================================
                 
         // Conflux Grail
         _PI->WriteDword      (0x5BE512, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x5BE56E, SPELLS_NUM * sizeof(_Spell_));
         _PI->WriteDword      (0x5D7464, SPELLS_NUM);
         
         // ===============================================================
         // ------------------ New Hero.spell[140] field ------------------
         // ---------------------------------------------------------------
         _PI->WriteCodePatch  (0x4D8B72, "%n", 8);
         _PI->WriteCodePatch  (0x4D8F7F, "%n", 8);
         // ===============================================================

         // ===============================================================
         // ------------- New Game.disabled_spells[140] field -------------
         // ---------------------------------------------------------------
         _PI->WriteByte       (0x4C16ED, 4); // Pyramids
         _PI->WriteByte       (0x4C254C, 4); // Titan's Lightning Bolt
         _PI->WriteByte       (0x4C25F1, 4); // Titan's Lightning Bolt
         _PI->WriteByte       (0x501297, 4); // Scholars
         _PI->WriteByte       (0x5BEA55, 4); // Mage Guild
         // ===============================================================
                         
         _PI->WriteDword      (0x52AE1C, 0x3EA);

         // ===============================================================
         // -------------------------- Combat -----------------------------
         // ---------------------------------------------------------------
         _PI->WriteByte       (0x4963E9, ANIMS_NUM);
         _PI->WriteByte       (0x4965BD, ANIMS_NUM);
         _PI->WriteByte       (0x502405, SPELLS_NUM);
         _PI->WriteByte       (0x502451, SPELLS_NUM);
         _PI->WriteByte       (0x5024CF, SPELLS_NUM);
         _PI->WriteByte       (0x502515, SPELLS_NUM);
         _PI->WriteByte       (0x502E62, SPELLS_NUM);
         _PI->WriteByte       (0x502EB7, SPELLS_NUM);
         _PI->WriteByte       (0x59EFD9, SPELLS_NUM - 1 - ORIG_ADVSPELLS_NUM);
         _PI->WriteDword      (0x59EFE4, (int)&spellIndirectTableA);
         _PI->WriteByte       (0x5A064E, SPELLS_NUM - 1 - ORIG_ADVSPELLS_NUM);
         _PI->WriteDword      (0x5A0659, (int)&spellIndirectTableB);

		 _PI->WriteLoHook	  (0x59EFE8, spellTableAHelper);
		 _PI->WriteLoHook	  (0x43B797, spellTableFHelper);
		 _PI->WriteLoHook	  (0x5A4CB3, showAreaAnim);
		 _PI->WriteLoHook	  (0x5A4D15, goldenTouchAreaAnim);
		 _PI->WriteLoHook	  (0x5A0E70, goldenTouchAddGoldSingleTarget);
		 _PI->WriteLoHook	  (0x5A4DF2, goldenTouchAddGold);
		 _PI->WriteLoHook	  (0x469941, appendCombatLogInfo);
		 _PI->WriteLoHook	  (0x46FE20, notifyPlayerAfterBattle);
		          
		 // army::SetSpellInfluence() switch
		 _PI->WriteByte       (0x4446EA, SPELLS_NUM - 1 - SPELL_SHIELD);
         _PI->WriteDword      (0x4446FD, (int)&SetSpellInfluenceTable);
         
		 _PI->WriteByte       (0x444262, SPELLS_NUM - 1 - SPELL_WEAKNESS);
         _PI->WriteDword      (0x44427A, (int)&spellIndirectTableD);
         _PI->WriteByte       (0x44A259, SPELLS_NUM - 1 - SPELL_LIGHTNING_BOLT);
         _PI->WriteDword      (0x44A264, (int)&spellIndirectTableE);
         _PI->WriteByte       (0x43B788, SPELLS_NUM - 1 - SPELL_EARTHQUAKE);
         _PI->WriteDword      (0x43B793, (int)&spellIndirectTableF);
         _PI->WriteHiHook     (0x43B2E0, SPLICE_, EXTENDED_, THISCALL_, get_enchantment_function);
         _PI->WriteLoHook     (0x43B797, consider_spell);
		 _PI->WriteLoHook     (0x44467E, setSpellInfluence);
         // ===============================================================
                 
         // ===============================================================
         // -------------- New army.spellInfluence[162] field -------------
         // ---------------------------------------------------------------
         _PI->WriteDword      (0x43787A, 162);
         _PI->WriteDword      (0x43D314, 162);
         _PI->WriteDword      (0x43E3DF, SPELLS_NUM);
         _PI->WriteByte       (0x443F63, SPELLS_NUM);
         _PI->WriteByte       (0x446F03, SPELLS_NUM);
         _PI->WriteByte       (0x5A1907, SPELLS_NUM);
         _PI->WriteByte       (0x5A1995, SPELLS_NUM);
         _PI->WriteByte       (0x5A84C8, SPELLS_NUM);
         _PI->WriteByte       (0x5A852F, SPELLS_NUM);
         // ===============================================================
        
         // Fear, Poison, Disease, Age, ...
         _PI->WriteLoHook     (0x444701, applySpell);
         _PI->WriteLoHook     (0x44427E, resetSpell);
         // Poison every round, no retaliations for Fear at Expert
         _PI->WriteLoHook     (0x446F11, newRoundSpellSettings);
         // Creature's cast
         _PI->WriteLoHook     (0x468CCF, creatureCast);
         // Zombie's Disease on Magic Plains
         _PI->WriteLoHook     (0x5A01E5, zombieDiseaseOnMagicPlains);
         // Allow to dispel Poison
         _PI->WriteHexPatch   (0x5A18FA, "90 90");
         _PI->WriteHexPatch   (0x5A1988, "90 90");
		 _PI->WriteCodePatch  (0x43972C, "%n", 12); // type_AI_spellcaster::get_cancel_value()

         // Allow to cure new spells
         _PI->WriteLoHook     (0x4462FD, cureNewSpells);

         // Death Cloud, Incineration
		 _PI->WriteLoHook     (0x41FBEB, get_area_effect_new);
		 _PI->WriteLoHook     (0x5A065D, castBattleSpell);
		 _PI->WriteLoHook     (0x5A4DE7, applyIncinerationSpecialFeature);
		 //_PI->WriteHiHook     (0x447050, SPLICE_, DIRECT_, THISCALL_, get_resurection_size);
		 		 
         // Death Blow
         _PI->WriteLoHook     (0x4435A9, DeathBlow);

         // Drain Life
         _PI->WriteLoHook     (0x440903, DrainLife);
         _PI->WriteLoHook     (0x44096F, calcDrainLifeHeal);

         // Summon Sprite, Summon Magic Elemental, Summon Firebird
         //_PI->WriteLoHook     (0x43D5B7, setOrigNumTroops);
		 _PI->WriteLoHook     (0x59F889, checkSummonedCreaturesType);
         _PI->WriteLoHook     (0x5A065D, SummonCreatures);
         _PI->WriteLoHook     (0x5A74D6, skipNonElementals);
         _PI->WriteLoHook     (0x5A7516, setSummonedCreaturesNumber);
         _PI->WriteHiHook     (0x5A96B0, SPLICE_, DIRECT_, THISCALL_, AbleToSummonElemental);
         _PI->WriteHiHook     (0x5A9670, SPLICE_, DIRECT_, FASTCALL_, get_elemental_type);
		 
		 // Adventure Spells
		 _PI->WriteLoHook     (0x41C663, castAdventureSpell);
		 _PI->WriteLoHook     (0x4915B7, eyeOfTheMagi);
		 _PI->WriteHiHook     (0x50CEA0, SPLICE_, EXTENDED_, THISCALL_, setMouseCursor);
		 _PI->WriteLoHook     (0x4AE130, mobilitySetWin);
		          
         // Stack's Magic Vulnerability
         _PI->WriteLoHook     (0x44A268, getStackMagicVulnerability);
         
         // Artifacts (incl. Spell Scrolls)
         _PI->WriteHiHook     (0x4D9840, SPLICE_, DIRECT_, THISCALL_, UpdateSpellsFromArtifacts);

         _PI->WriteHiHook     (0x4425A0, SPLICE_, DIRECT_, THISCALL_, can_attack);
		 _PI->WriteHiHook     (0x4C7CA0, SPLICE_, EXTENDED_, THISCALL_, beforeNewDayStart);
		 _PI->WriteHiHook     (0x4C2110, SPLICE_, EXTENDED_, THISCALL_, beforeNewGameStart);
		          
         // ===============================================================
         // ---------------------------- Fear -----------------------------
         // ---------------------------------------------------------------
         // Set cursor for human players
         _PI->WriteHiHook     (0x475DC0, SPLICE_, EXTENDED_, THISCALL_, setCursorForFearSpell);
         // Not allowing to attack under Fear
         _PI->WriteLoHook     (0x422088, skipMeleeAttackUnderFear);
         _PI->WriteLoHook     (0x41F25C, skipShootingUnderFear);
         // Getting defense modifier (common for Blind, Paralyze, Fear)
         _PI->WriteHiHook     (0x4422B0, SPLICE_, DIRECT_, THISCALL_, GetEffectiveDefenseAgainst);
		 _PI->WriteHiHook     (0x4438B0, SPLICE_, DIRECT_, THISCALL_, ComputeAttackerDamageReduction);
         // ===============================================================

         _PI->WriteHiHook     (0x4631E0, SPLICE_, EXTENDED_, THISCALL_, combatManagerLoadArmies);
		 _PI->WriteHiHook     (0x476DA0, SPLICE_, EXTENDED_, THISCALL_, combatManagerDoVictory);

		 // Hour of Power. Bless
		 _PI->WriteHiHook     (0x442410, SPLICE_, DIRECT_, THISCALL_, get_average_damage);
		 _PI->WriteLoHook	  (0x4424A9, getAverageDamageInt);
		 _PI->WriteLoHook	  (0x4429B4, getUnitCombatValue);
		 _PI->WriteLoHook	  (0x442F64, randomizeBasicDamage);
		 _PI->WriteLoHook	  (0x443480, computeAttackerDamageBonuses);
		 _PI->WriteLoHook	  (0x492F9F, getAttackDamageHintString);
		 // Hour of Power. Bloodlust
		 _PI->WriteLoHook	  (0x44215A, getAdjustedAttack_Bloodlust);
		 _PI->WriteLoHook	  (0x43BF8D, getOgreMageValue);
		 // Hour of Power. Fortune
		 _PI->WriteLoHook	  (0x43DC9F, hourOfPower_Fortune);
		 // Hour of Power. Slayer
		 _PI->WriteLoHook	  (0x44216F, getAdjustedAttack_Slayer);
		 // Hour of Power. Spell immunities
		 _PI->WriteHiHook     (0x5A83A0, SPLICE_, EXTENDED_, THISCALL_, SpellCastWorkChance);
		 
		 // Speed
		 _PI->WriteHiHook     (0x4489F0, SPLICE_, DIRECT_, THISCALL_, GetSpeed);
		 		 
		 int speedModJmpAddr[] = {0x441CE3, 0x441E06, 0x44857E, 0x4485BC, 0x4485FC, 0x44867A};
		 for (std::size_t i = 0; i < sizeof(speedModJmpAddr) / sizeof(int); ++i)
            _PI->WriteHexPatch(speedModJmpAddr[i], "90 90");

		 // Cumulative unicorn aura
		 if (GetPrivateProfileIntA("Options", "<Gameplay.CumulativeUnicornAura>", 0, iniPath) == 1)
			_PI->WriteLoHook     (0x5A88A9, cumulativeUnicornAura);

		 // ===============================================================
         // ---------------------- Save & Load Game -----------------------
         // ---------------------------------------------------------------
		 _PI->WriteLoHook     (0x4D7D44, loadHeroAdvInfoEx);
		 _PI->WriteLoHook     (0x4D83B3, saveHeroAdvInfoEx);
		 
		 _PI->WriteDword	  (0x41814E, (int&)gmnExt); // .GM%d
		 _PI->WriteDword	  (0x418139, (int&)cgmExt); // .CGM
		 _PI->WriteDword	  (0x4BEC71, (int&)gmnStr); // %s.GM%d
		 _PI->WriteDword	  (0x4BEC27, (int&)cgmStr); // CGM
		 _PI->WriteDword	  (0x4BEC3B, (int&)tgmStr); // TGM
		 _PI->WriteDword	  (0x6834AC, (int&)gmnMsk); // *.gm?
		 _PI->WriteDword	  (0x6834B0, (int&)cgmMsk); // *.cgm
		 _PI->WriteDword	  (0x6834B8, (int&)tgmMsk); // *.tgm
		 // ===============================================================

		 // LOD
		 _PI->WriteDword	  (0x69E5B8, 3);
		 _PI->WriteDword	  (0x69E5B8 + 4, (int)&lodType);
		 _PI->WriteLoHook     (0x55A57D, loadLod);

		 // SND
		 _PI->WriteLoHook     (0x598979, loadSnd);
		 
		 // Debug AI
#ifdef NEWSPELLS_DEBUG
		 _PI->WriteHiHook     (0x436610, SPLICE_, EXTENDED_, THISCALL_, AIShowInfo);
#endif
      }
   }

   return TRUE;
}